//#16.0.1.0 WDPlanning.js
//VersionVI: 30F160038f
// Le seul support technique disponible pour cette librairie est
// accessible a travers le service "Assistance Directe".

// Manipulation d'un champ planning
function WDPlanning (sAliasChamp, sAliasZR, sAliasAttribut)
{
	// Si on est pas dans l'init d'un protoype
	if (sAliasChamp)
	{
		// Appel le constructeur de la classe de base
		WDChampParametres.prototype.constructor.apply(this, arguments);
	}
};

// Declare l'heritage
WDPlanning.prototype = new WDChampParametres();
// Surcharge le constructeur qui a ete efface
WDPlanning.prototype.constructor = WDPlanning;

// Membres statiques
// Zone generale
WDPlanning.prototype.ms_sNomGenerale = "WDPLN-ZoneGenerale";
// Zone d'affichage des titres de ressources
WDPlanning.prototype.ms_sNomTitre = "WDPLN-ZoneTitre";
// Zone d'affichage des donnees
WDPlanning.prototype.ms_sNomCorps = "WDPLN-ZoneCorps";
WDPlanning.prototype.ms_sNomCorpsQuadrillage = "WDPLN-ZoneCorpsQuadrillage";
WDPlanning.prototype.ms_sNomCorpsHauteurTotale = "WDPLN-ZoneCorpsHauteurTotale";
// Coloration de la colonne
WDPlanning.prototype.ms_sNomColCouleur = "WDPLN-ColCouleur";
// Premiere colonne
WDPlanning.prototype.ms_sNomColGauche = "WDPLN-ColGauche";
// Colonnes suivantes
WDPlanning.prototype.ms_sNomColRessource = "WDPLN-ColRessource";
WDPlanning.prototype.ms_sNomColRessourcePremier = "WDPLN-ColRessourcePremier";
WDPlanning.prototype.ms_sNomColRessourceConteneur = "WDPLN-ColRessourceConteneur";
// Rendez-vous
WDPlanning.prototype.ms_sNomRendezVousExterne = "WDPLN-RendezVousExterne";
WDPlanning.prototype.ms_sNomRendezVous = "WDPLN-RendezVous";
WDPlanning.prototype.ms_sNomRendezVousSelect = "WDPLN-RendezVousSelect";
WDPlanning.prototype.ms_sNomRendezVousImage = "WDPLN-RendezVousImage";
WDPlanning.prototype.ms_sNomRendezVousTitre = "WDPLN-RendezVousTitre";
WDPlanning.prototype.ms_sNomRendezVousSupprime = "WDPLN-RendezVousSupprime";
// Les heures
WDPlanning.prototype.ms_sNomFondCouleur = "WDPLN-FondCouleur";
WDPlanning.prototype.ms_sNomFondBordure = "WDPLN-FondBordure";
WDPlanning.prototype.ms_sNomFondRupture = "WDPLN-FondRupture";
WDPlanning.prototype.ms_sNomJour = "WDPLN-Jour";
WDPlanning.prototype.ms_sNomHeure = "WDPLN-Heure";
WDPlanning.prototype.ms_sNomHeureDemi = "WDPLN-HeureDemi";
WDPlanning.prototype.ms_sNomHeureLibelle = "WDPLN-HeureLibelle";
WDPlanning.prototype.ms_tabHeureSuffixe = ["Normal", "HorsBornes", "Aujourdhui", "Samedi", "Dimanche", "Ferie"];
// La zone de redimensionnement
//WDPlanning.prototype.ms_sNomRDVRedimHaut = "WDPLN-RDVRedimHaut";
WDPlanning.prototype.ms_sNomRDVRedimBas = "WDPLN-RDVRedimBas";
WDPlanning.prototype.ms_sNomRDVRepetition = "WDPLN-RDVRepetition";
WDPlanning.prototype.ms_sNomRDVImportance = "WDPLN-RDVImportance";
// Commandes
// Commandes pour les champs agenda/planning
//WDPlanning.prototype.ms_sActionAgendaRdvSelection = "AGENDARDVSEL";
WDPlanning.prototype.ms_sActionAgendaRdvDeplacement = "AGENDARDVDEP";
WDPlanning.prototype.ms_sActionAgendaRdvRedim = "AGENDARDVRED";
//WDPlanning.prototype.ms_sActionAgendaPeriodeSelect = "AGENDAPERSEL";
WDPlanning.prototype.ms_sActionAgendaRdvSupprime = "AGENDARDVSUP";
WDPlanning.prototype.ms_sActionAgendaRdvAjoute = "AGENDARDVAJO";
//WDPlanning.prototype.ms_sActionAgendaRdvEdition = "AGENDARDVEDI";
WDPlanning.prototype.ms_sActionAgendaRdvModifTitre = "AGENDARDVEDT";
//WDPlanning.prototype.ms_sActionAgendaPlanningDeplacementRessource = "PLANNINGRDVDES";
// Superposition
WDPlanning.prototype.ms_eSuperpositionCoteACote = 0;
WDPlanning.prototype.ms_eSuperpositionDecalage = 1;
// Images
WDPlanning.prototype.ms_sImageSupprimeDefaut = "pl_delete.gif";
WDPlanning.prototype.ms_sImageRepetitionDefaut = "pl_rdvrepete.gif";
WDPlanning.prototype.ms_sImageImportanceDefaut = "pl_rdvimportant.png";

// Paddings
WDPlanning.prototype.ms_nPaddingLibJour = 3;

// Les z-Index du champ
// 0 : Fond des lignes
WDPlanning.prototype.ms_nZIndexFondLigne = 0;
// 1 : Fond des colonnes
WDPlanning.prototype.ms_nZIndexFondColonne = 1;
// 2 : Bordure des lignes
WDPlanning.prototype.ms_nZIndexFondBordure = 2;
	// 3 : Date et heure (libelles)
// 4 : Rendez-vous
WDPlanning.prototype.ms_nZIndexRendezVous = 4;
// 5 : Rendez-vous selectionne
WDPlanning.prototype.ms_nZIndexRendezVousSelection = 5;
// 6 : Rupture sur les jours (si presente)
WDPlanning.prototype.ms_nZIndexFondRupture = 6;
// 7 : Bouton de suppression
WDPlanning.prototype.ms_nZIndexRendezVousSupprime = 7;

// Declare les fonction une par une

// Initialisation :
WDPlanning.prototype.Init = function Init()
{
	// Appel de la methode de la classe de base
	WDChampParametres.prototype.Init.apply(this, arguments);

	// Les callbacks
	var oThis = this;
	this.m_fOnRendezVousSupprime = function(oEvent) { oEvent = oEvent ? oEvent : event; oThis.OnRendezVousSupprime(oEvent); }
	this.m_fOnScrollCorps = function(oEvent) { oEvent = oEvent ? oEvent : event; oThis.OnScrollCorps(oEvent); }

	// Reconstruit le HTML
	this.__Reinit();

	// Pour le mode AWP on refixe dans le champ formulaire la selection
	this.ConstruitParam();
};

// Methode d'initialisation generale de la classe
// Filtre et ne s'execute que lors de l'init du PREMIER champ de ce type
WDPlanning.prototype._vInitInitiale = function _vInitInitiale()
{
	// Appel de la methode de la classe de base
	WDChampParametres.prototype._vInitInitiale.apply(this, arguments);

	// Creation de la feuille de style globale
	WDPlanning.prototype.ms_oFeuilleStyleGlobale = this.__oCreeFeuilleStyle(); ;

	// Ajout des regles
	this.__StyleCreeGlobal("." + this.ms_sNomTitre, ["overflow:hidden"]);
	this.__StyleCreeGlobal("." + this.ms_sNomCorps, ["overflow-x:auto", "overflow-y:scroll", "position:relative"]);
	this.__StyleCreeGlobal("td." + this.ms_sNomCorpsQuadrillage, ["height:0px"]);
	this.__StyleCreeGlobal("." + this.ms_sNomCorps + " div." + this.ms_sNomColGauche, ["z-index:" + this.ms_nZIndexFondColonne, "position:absolute"]);
	this.__StyleCreeGlobal("." + this.ms_sNomCorps + " div." + this.ms_sNomColRessource, ["z-index:" + this.ms_nZIndexFondColonne, "position:absolute"]);
	this.__StyleCreeGlobal("." + this.ms_sNomTitre + " div." + this.ms_sNomColRessource, ["padding-left:2px", "padding-right:2px", "text-overflow:ellipsis", "white-space:nowrap", "overflow:hidden"]);
	this.__StyleCreeGlobal("." + this.ms_sNomColRessourceConteneur, ["z-index:" + this.ms_nZIndexRendezVous, "position:relative"]);
	var nOffsetPadding = 0;
	if (bIEQuirks)
	{
		this.__StyleCreeGlobal("." + this.ms_sNomRendezVousExterne, ["padding-left:1px", "padding-right:5px"]);
		nOffsetPadding = 5;
	}
	this.__StyleCreeGlobal("." + this.ms_sNomRendezVous, ["cursor:default"]);
	this.__StyleCreeGlobal("." + this.ms_sNomRendezVousExterne, ["overflow-y:hidden"]);
	this.__StyleCreeGlobal("." + this.ms_sNomRendezVousExterne + " div", ["overflow:hidden"]);
	this.__StyleCreeGlobal("." + this.ms_sNomRendezVousImage, ["background-position:bottom left", "background-repeat:no-repeat"]);
	this.__StyleCreeGlobal("." + this.ms_sNomRendezVousTitre + " div", ["text-overflow:ellipsis", "white-space:nowrap", "padding-bottom:2px"]);
	this.__StyleCreeGlobal("." + this.ms_sNomRendezVousSupprime, ["z-index:" + this.ms_nZIndexRendezVousSupprime, "position:absolute"]);
	this.__StyleCreeGlobal("div." + this.ms_sNomRDVRedimBas, ["position:absolute", "bottom:0px"]);
	this.__StyleCreeGlobal("." + this.ms_sNomRDVRepetition, ["position:absolute", "top:3px", bIEQuirks ? "right:8px" : "right:3px"]);
	this.__StyleCreeGlobal("." + this.ms_sNomRDVImportance, ["position:absolute", "bottom:3px", bIEQuirks ? "right:8px" : "right:3px"]);
	this.__StyleCreeGlobal("." + this.ms_sNomFondCouleur, ["z-index:" + this.ms_nZIndexFondLigne, "position:absolute"]);
	this.__StyleCreeGlobal("." + this.ms_sNomFondCouleur + " div", ["z-index:0"]);
	this.__StyleCreeGlobal("." + this.ms_sNomFondBordure, ["z-index:" + this.ms_nZIndexFondBordure, "position:absolute"]);
	this.__StyleCreeGlobal("." + this.ms_sNomFondRupture, ["z-index:" + this.ms_nZIndexFondRupture, "position:absolute", "height:0px", "width:0px", "overflow:visible"]);
	this.__StyleCreeGlobal("." + this.ms_sNomFondRupture + " div", ["z-index:" + this.ms_nZIndexFondRupture, "overflow:hidden"]);
	this.__StyleCreeGlobal("." + this.ms_sNomFondRupture + " div." + this.ms_sNomJour, ["position:absolute", "padding-left:" + this.ms_nPaddingLibJour + "px", "padding-right:" + this.ms_nPaddingLibJour + "px"]);
	this.__StyleCreeGlobal("." + this.ms_sNomHeure, ["position:relative", "left:0px", "right:0px"]);
	this.__StyleCreeGlobal("." + this.ms_sNomHeureDemi, ["position:absolute"]);
	this.__StyleCreeGlobal("." + this.ms_sNomHeureLibelle, ["overflow:hidden"]);
	this.__StyleCreeGlobal("." + this.ms_sNomHeureLibelle + " span", ["padding-left:3px", "padding-right:3px", "vertical-align:center"]);

	// Prechargement des images
	WDPlanning.prototype.ms_sImageSupprime = _WD_ + "res/" + this.ms_sImageSupprimeDefaut;
	(new Image()).src = this.ms_sImageSupprime;
	WDPlanning.prototype.ms_sImageRepetition = _WD_ + "res/" + this.ms_sImageRepetitionDefaut;
	(new Image()).src = this.ms_sImageRepetition;
	WDPlanning.prototype.ms_sImageImportance = _WD_ + "res/" + this.ms_sImageImportanceDefaut;
	(new Image()).src = this.ms_sImageImportance;

	// S'auto efface pour ne plus etre appele
	WDPlanning.prototype._vInitInitiale = WDChamp.prototype.m_pfVide;
};

// Trouve les divers elements : liaison avec le HTML
WDPlanning.prototype._vLiaisonHTML = function _vLiaisonHTML()
{
	// Appel de la methode de la classe de base
	WDChampParametres.prototype._vLiaisonHTML.apply(this, arguments);

	// La zone de dessin
	this.m_oHote = this.oGetElementById(document, this.ms_sSuffixeHote);
};

// Construit tous le HTML si besoin
WDPlanning.prototype.__Reinit = function __Reinit(bAvecCSS)
{
	// On effectue la laison avec la selection
	this.__TrouveSelection();

	// Si l'element n'est pas visible : fini
	if (!clWDUtil.bEstDisplay(this.m_oHote, document))
	{
		return;
	}

	// Init les variables
	this.m_nScrollCorps = 0;

	// Si c'est le premier affichage
	if (!this.m_bPremierAffichageFait)
	{
		// Initialise les differents evenements
		this.__InitEvents();

		// Construit le HTML (HTML fait l'appel de __InitCSS)
		this.__HTMLAfficheBase();

		// Affiche le contenu
		this.__HTMLAfficheContenu(false);

		this.m_bPremierAffichageFait = true;
	}
	else
	{
		if (bAvecCSS)
		{
			this.__InitCSS();
		}

		// Reaffiche le contenu du champ
		this.__HTMLAfficheContenu(true);
	}
};

// Construit le HTML de base
WDPlanning.prototype.__HTMLAfficheBase = function __HTMLAfficheBase()
{
	// Initialise les styles
	this.__InitCSS();

	var sIDZoneTitre = this.sGetSuffixeIDElement(this.ms_sNomTitre);
	var sIDZoneCorps = this.sGetSuffixeIDElement(this.ms_sNomCorps);
	// Genere la table externe
	var tabHTML = [];
	tabHTML.push("<table class=\"");
	tabHTML.push(this.ms_sNomGenerale);
	tabHTML.push("\">");
	tabHTML.push("<tr><td>");
	this.__HTMLAfficheDiv(tabHTML, this.ms_sNomTitre, this.sGetNomElement(sIDZoneTitre));
	tabHTML.push("</td></tr><tr><td>");
	this.__HTMLAfficheDiv(tabHTML, this.ms_sNomCorps, this.sGetNomElement(sIDZoneCorps));
	tabHTML.push("</td></tr></table>");
	this.m_oHote.innerHTML = tabHTML.join("");

	// Recupere les conteneurs
	this.m_oHoteTitres = this.oGetElementById(document, sIDZoneTitre);
	this.m_oHoteCorps = this.oGetElementById(document, sIDZoneCorps);

	// Initialisation du style des libelle des jours
	this.__InitCSS_Specifique_LibJour();

	// Synchronise le scroll du haut et du bas
	HookOnXXX(this.m_oHoteCorps, 'onscroll', 'scroll', this.m_fOnScrollCorps);
};

// Cree le selecteur pour une classe
WDPlanning.prototype.__sGetSelecteur = function __sGetSelecteur(sClasse1, sTag, sClasse2)
{
	var tabSelecteur = [];
	tabSelecteur.push('#' + this.m_sAliasChamp + this.ms_sSuffixeHote);
	if (sClasse1 !== undefined)
	{
		tabSelecteur.push('.' + sClasse1);
	}
	tabSelecteur.push(sTag + '.' + sClasse2);
	return tabSelecteur.join(' ');
};

// Initialise les styles
WDPlanning.prototype.__InitCSS = function __InitCSS()
{
	// Creation de la feuille de style locale
	this.m_oFeuilleStyle = this.__oCreeFeuilleStyle();
	this.m_oFeuilleStyleRules = bIE ? this.m_oFeuilleStyle.rules : this.m_oFeuilleStyle.cssRules;

	// Et initialise les styles du champ
	var nLargeur = this.__nGetLargeur();

	// Zone generale : taille
	this.__StyleCree(this.__sGetSelecteur(undefined, "", this.ms_sNomGenerale), ["width:" + nLargeur + "px", "height:" + this.__nGetHauteur() + "px"]);
	// Zone de titre : taille
	this.__StyleCree(this.__sGetSelecteur(undefined, "div", this.ms_sNomTitre), ["width:" + nLargeur + "px", "height:" + this.m_oParametres.m_nHauteurTitre + "px"]);
	this.__StyleCree(this.__sGetSelecteur(undefined, "table", this.ms_sNomTitre), ["height:" + this.m_oParametres.m_nHauteurTitre + "px"]);

	var oStyleColGauche = this.m_oParametres.m_oStyleLibHeure;
	// Colonne de gauche
	this.__InitCSS_Specifique_Col(this.ms_sNomColGauche, this.m_oParametres.m_oColGauche, oStyleColGauche, true);
//	// => Ce style doit etre ici (et pas dans la partie generale) car il doit etre plus specifique que le style precedent et donc avoir le #id
//	this.__StyleCree(this.__sGetSelecteur(this.ms_sNomTitre, "td", this.ms_sNomColGauche), ["border-left:none"]);

	// Hauteur du bloc de corps
	this.__StyleCree(this.__sGetSelecteur(undefined, "", this.ms_sNomCorps), ["width:" + nLargeur + "px", "height:" + this.__nGetHauteurCorps() + "px"]);

	// Colonne(s) de ressource(s)
	this.__InitCSS_Specifique_Ressources();

	// Styles des heures
	this.__InitCSS_Specifique_Heure();

	// Styles des rendez-vous
	this.__InitCSS_Specifique_RendezVous();
};

// Initialise le style specifique d'une colonne
WDPlanning.prototype.__InitCSS_Specifique_Col = function __InitCSS_Specifique_Col(sClasse, oCol, oStyle, bColGauche) {
	// Style general sur la largeur
	this.__StyleCree(this.__sGetSelecteur(undefined, "td", sClasse), this.__tabInitCSS_Specifique_ColLargeur([], oCol.m_nLargeur));
	// Il n'y a aucune bordure sur la colonne de gauche
	var nLargeurDiv = bColGauche ? oCol.m_nLargeur : this.__nGetColLargeur(oCol, oStyle);
	this.__StyleCree(this.__sGetSelecteur(undefined, "div", sClasse), this.__tabInitCSS_Specifique_ColLargeur([], nLargeurDiv));

	if (oStyle.m_cFond && bColGauche) {
		// Le style du div de la couleur
		this.__StyleCree(this.__sGetSelecteur(sClasse, "", this.ms_sNomColCouleur), ["background-color:" + oStyle.m_cFond]);
	}

	// Le style des TD avec la bordure
	this.__StyleCree(this.__sGetSelecteur(undefined, "div", this.ms_sNomColRessource), this.__tabInitCSS_Specifique_ColBordures([], null, oStyle));
};

// Construit une largeur stricte
WDPlanning.prototype.__tabInitCSS_Specifique_ColLargeur = function __tabInitCSS_Specifique_ColLargeur(tabStyle, nLargeur)
{
	tabStyle.push("width:" + nLargeur + "px");
	tabStyle.push("min-width:" + nLargeur + "px");
	tabStyle.push("max-width:" + nLargeur + "px");
	return tabStyle;
};

// Construit le style pour les bordure gauche et droite
WDPlanning.prototype.__tabInitCSS_Specifique_ColBordures = function __tabInitCSS_Specifique_ColBordures(tabStyle, oStyleGauche, oStyleDroit)
{
	// Bordure gauche
	if (oStyleGauche && (0 < oStyleGauche.m_nBordureV))
	{
		tabStyle.push("border-left:solid " + oStyleGauche.m_nBordureV + "px " + oStyleGauche.m_cBordureV);
	}
	// Bordure droite
	if (oStyleDroit && (0 < oStyleDroit.m_nBordureV))
	{
		tabStyle.push("border-right:solid " + oStyleDroit.m_nBordureV + "px " + oStyleDroit.m_cBordureV);
	}
	return tabStyle;
};

// Initialisation du style des ressources
WDPlanning.prototype.__InitCSS_Specifique_Ressources = function __InitCSS_Specifique_Ressources() {
	var oStyleColRessource = this.m_oParametres.m_oStyleNormal;
	var oStyleColGauche = this.m_oParametres.m_oStyleLibHeure;
	// Il ne faut pas prendre la couleur de fond le style des lignes a ete fusionne correctement avec le style de base
	this.__InitCSS_Specifique_Col(this.ms_sNomColRessource, this.m_oParametres.m_oColRessource, oStyleColRessource, false);
	this.__StyleCree(this.__sGetSelecteur(this.ms_sNomColRessourcePremier, "div", this.ms_sNomColRessource), this.__tabInitCSS_Specifique_ColBordures([], oStyleColGauche, oStyleColRessource));

	var oStyleLibRessource = this.m_oParametres.m_oStyleLibRessource;
	if (0 < oStyleLibRessource.m_nBordureV) {
		this.__StyleCree(this.__sGetSelecteur(this.ms_sNomTitre, "td", this.ms_sNomColRessource), ["border-top:solid " + oStyleLibRessource.m_nBordureV + "px " + oStyleLibRessource.m_cBordureV]);
	}
	// 4 = 2 * 2 (le padding) + bordure
	var nMoins = bIEQuirks ? 0 : 4;
	var tabStyle = this.__tabInitCSS_Specifique_ColLargeur([], this.__nGetColLargeur(this.m_oParametres.m_oColRessource, oStyleLibRessource) - nMoins);
	if (oStyleLibRessource.m_cFond) {
		tabStyle.push("background-color:" + oStyleLibRessource.m_cFond);
	}
	tabStyle.push("height:" + this.m_oParametres.m_nHauteurTitre + "px");
	this.__StyleCree(this.__sGetSelecteur(this.ms_sNomTitre, "div", this.ms_sNomColRessource), tabStyle);
};

// Initialisation du style des heures
WDPlanning.prototype.__InitCSS_Specifique_Heure = function __InitCSS_Specifique_Heure()
{
	// Style (largeur) des zones
	// Le positionnement est dans des styles generaux
	var nLargeurTotale = this.m_oParametres.m_oColGauche.m_nLargeur + this.m_oDonnees.m_tabRessources.length * this.m_oParametres.m_oColRessource.m_nLargeur;
	this.__StyleCree(this.__sGetSelecteur(undefined, "", this.ms_sNomFondCouleur), ["width:" + nLargeurTotale + "px"]);
	this.__StyleCree(this.__sGetSelecteur(undefined, "", this.ms_sNomFondBordure), ["width:" + nLargeurTotale + "px"]);

	// Style general : hauteur d'une heure
	this.__StyleCree(this.__sGetSelecteur(undefined, "", this.ms_sNomHeure), ["height:" + this.m_oParametres.m_nHauteurHeure + "px"]);
	var tabStyle = [];
	tabStyle.push("height:" + this.m_oParametres.m_nHauteurHeure + "px");
	tabStyle.push("width:" + this.m_oParametres.m_oColGauche.m_nLargeur + "px");
	tabStyle.push("line-height:" + this.m_oParametres.m_nHauteurHeure + "px");
	this.__StyleCree(this.__sGetSelecteur(undefined, "", this.ms_sNomHeureLibelle), tabStyle);

	// Couleur des heures
	var i;
	var nLimiteI = this.ms_tabHeureSuffixe.length;
	for (i = 0; i < nLimiteI; i++)
	{
		this.__InitCSS_Specifique_UneHeure(this.ms_tabHeureSuffixe[i], nLargeurTotale, this.m_oParametres.m_oColGauche.m_nLargeur);
	}

//	// Si on n'a pas de ressources, calcule avec une ressource (on a recu la largeur du serveur qui tient compte de cette valeur)
//	if (0 == this.m_oDonnees.m_tabRessources.length)
//	{
//		nLargeurTotale = this.m_oParametres.m_oColGauche.m_nLargeur + this.m_oParametres.m_oColRessource.m_nLargeur;
//	}
//
//	// Initialisation du style des libelle des jours
//	this.__InitCSS_Specifique_LibJour(this.m_oHoteCorps.clientWidth)
};

// Calcule la largeur du libelle du jour
WDPlanning.prototype.nGetLargeurLibJour = function nGetLargeurLibJour(nLargeurCorpsClient, nOffsetLibJour)
{
	// Il faudrait prendre la largeur effective (this.__nGetLargeur()) du champ et pas la largeur des ressource
	// sauf que avec ce code on ne detecte pas bien le defilement puisque les ruptures sont dans la zone basse donc si la zone se reduit cela ne fonctionne pas
	// Il faut tenir compte du padding pour les navigateurs respectant la norme.
	return nLargeurCorpsClient + nOffsetLibJour - 2 * (bIEQuirks ? 0 : this.ms_nPaddingLibJour);
};

// Initialisation du style des libelle des jours
WDPlanning.prototype.__InitCSS_Specifique_LibJour = function __InitCSS_Specifique_LibJour()
{
	// Style general : hauteur d'une rupture de jour
	if (this.m_oParametres.m_nHauteurLibJour)
	{
		var oStyle = this.m_oParametres.m_oStyleLibJourSemaine;

		var tabStyle = [];
		// Si on a une couleur de fond : normalement oui
		if (oStyle.m_cFond)
		{
			tabStyle.push("background-color:" + oStyle.m_cFond);
		}
		// Il faudrait prendre la largeur effective (this.__nGetLargeur()) du champ et pas la largeur des ressource
		var nOffsetLibJour = this.__nGetOffsetLibJour();
		this.m_nLargeurLibJour = this.nGetLargeurLibJour(this.m_oHoteCorps.clientWidth, nOffsetLibJour);
		var nHauteur = this.m_oParametres.m_nHauteurLibJour + nOffsetLibJour;
		if (0 < oStyle.m_nBordureV)
		{
			var nBordure = oStyle.m_nBordureV;
			var oBordureCouleur = oStyle.m_cBordureV;
			tabStyle.push("border:solid " + nBordure + "px " + oBordureCouleur);
		}
		tabStyle.push("height:" + nHauteur + "px");
		tabStyle.push("width:" + this.m_nLargeurLibJour + "px");
		tabStyle.push("left:" + this.m_nScrollCorps + "px");
		this.__StyleCree(this.__sGetSelecteur(undefined, "", this.ms_sNomJour), tabStyle);
	}
};

// Modification de la largeur/hauteur du libelle des jours de la semaine pour tenir compte de la bordure et du mode quirks
// Attention : on retourne la valeur en negatif, faire un +=
WDPlanning.prototype.__nGetOffsetLibJour = function __nGetOffsetLibJour()
{
	var oStyle = this.m_oParametres.m_oStyleLibJourSemaine;
	if (0 < oStyle.m_nBordureV)
	{
		var nBordure = oStyle.m_nBordureV;
		if (!bIEQuirks)
		{
			return -2 * nBordure;
		}
	}
	return 0
};

// Initialisation du style des heures
WDPlanning.prototype.__InitCSS_Specifique_UneHeure = function __InitCSS_Specifique_UneHeure(sSuffixe, nLargeurTotale, nColGaucheLargeur)
{
	var sClasse = "WDPLN-" + sSuffixe;
	// Recupere le style demande
	var oStyle = this.m_oParametres["m_oStyle" + sSuffixe];

	// Si on a une couleur de fond
	if (oStyle.m_cFond)
	{
		this.__StyleCree(this.__sGetSelecteur(this.ms_sNomFondCouleur, "", sClasse), ["background-color:" + oStyle.m_cFond]);
	}

	// Style des brodures (demi-heures)
	var tabStyle = [];
	var nHauteurDemiHeure = this.m_oParametres.m_nHauteurHeure / 2;
	if (0 < oStyle.m_nBordureV)
	{
		var nBordure = oStyle.m_nBordureV;
		var oBordureCouleur = oStyle.m_cBordureV;
		// On veux que le trait soit au debut de la demi heure donc il faut l'epaisseur en pixel supplementaire
		// Donc au lieu de faire :
		//	- compat : + 0 * bordure
		//	- strict : - 2 * bordure
		// On fait decale de 1 :
		//	- compat : + 1 * bordure
		//	- strict : - 1 * bordure
		if (bIEQuirks)
		{
			nHauteurDemiHeure += nBordure; // - * 1 et pas - * 2
		}
		else
		{
			nHauteurDemiHeure -= nBordure; // - * 1 et pas - * 2
		}
		tabStyle.push("border-top:" + nBordure + "px solid " + oBordureCouleur);
		tabStyle.push("border-bottom:" + nBordure + "px dotted " + oBordureCouleur);
		var tabStyleLibelle = [];
		tabStyleLibelle.push("border-top:" + nBordure + "px solid " + oBordureCouleur);
		// Normalement la couleur de fond dans la premiere colonne est dessous donc cela ne pose pas de probleme
		// couleur dans tr.WDPLN-ZoneCorpsHauteurTotale/td.WDPLN-ColGauche/div."WDPLN-ColGauche WDPLN-ColCouleur WDPLN-ZoneCorpsHauteurTotale"
		tabStyleLibelle.push("background-color:transparent");
		this.__StyleCree(this.__sGetSelecteur(this.ms_sNomFondBordure + " ." + sClasse, "", this.ms_sNomHeureLibelle), tabStyleLibelle);
	}
	// Ajoute un debut a gauche
	tabStyle.push("left:" + nColGaucheLargeur + "px");

	tabStyle.push("height:" + nHauteurDemiHeure + "px");
	tabStyle.push("width:" + (nLargeurTotale - nColGaucheLargeur) + "px");
	this.__StyleCree(this.__sGetSelecteur(this.ms_sNomFondBordure + " ." + sClasse, "", this.ms_sNomHeureDemi), tabStyle);
};

// Styles des rendez-vous
WDPlanning.prototype.__InitCSS_Specifique_RendezVous = function __InitCSS_Specifique_RendezVous()
{
	// Le style des rendez-vous
	this.__InitCSS_Specifique_RendezVous_UnStyle("m_oStyleRendezVous", this.ms_sNomRendezVous);
	// Le style du rendez-vous selectionne
	this.__InitCSS_Specifique_RendezVous_UnStyle("m_oStyleRendezVousSelect", this.ms_sNomRendezVousSelect);
};

WDPlanning.prototype.__BorderRadius = function __BorderRadius(tabStyle, nRadius, bTop)
{
	var tabBorderRadius = [];
	if (bFF)
	{
		tabBorderRadius.push("-moz");
	}
	else if (bWK)
	{
		tabBorderRadius.push("-webkit");
	}
	tabBorderRadius.push("border");
	tabBorderRadius.push("radius");
	tabBorderRadius = [tabBorderRadius.join('-')];
	tabBorderRadius.push(':');
	var nRadiusTop = ((bTop === undefined) || bTop) ? nRadius : 0;
	var nRadiusBottom = ((bTop === undefined) || !bTop) ? nRadius : 0;
	tabBorderRadius.push(nRadiusTop);
	tabBorderRadius.push("px ");
	tabBorderRadius.push(nRadiusTop);
	tabBorderRadius.push("px ");
	tabBorderRadius.push(nRadiusBottom);
	tabBorderRadius.push("px ");
	tabBorderRadius.push(nRadiusBottom);
	tabBorderRadius.push("px");
	tabStyle.push(tabBorderRadius.join(""));
};

// Un des tyles des rendez-vous
WDPlanning.prototype.__InitCSS_Specifique_RendezVous_UnStyle = function __InitCSS_Specifique_RendezVous_UnStyle(sStyle, sClass)
{
	// Recupere le style pour le rendez-vous selectionne
	oStyle = this.m_oParametres[sStyle];

	// Style des brodures (demi-heures)
	if (0 < oStyle.m_nBordureV)
	{
		var tabStyle = [];
		tabStyle.push("border:solid " + oStyle.m_nBordureV + "px " + oStyle.m_cBordureV);

		var tabStyleBas = [];
		// En mode quirks, IE9 n'affiche pas les bord arrondi
//		// Bordure arrondie dans tous les navigateurs autres que IE8-
		if (!bIE || ((8 > nIE) && !bIEQuirks))
		{
			tabStyle.push("border-collapse:separate");
			this.__BorderRadius(tabStyle, 5);

			var nRadiusInterne = Math.max(0, 5 - oStyle.m_nBordureV);
			if (0 < nRadiusInterne)
			{
				var tabStyleHaut = [];
				this.__BorderRadius(tabStyleHaut, nRadiusInterne, true);
				this.__StyleCree(this.__sGetSelecteur(sClass, "", this.ms_sNomRendezVousTitre), tabStyleHaut);
				this.__BorderRadius(tabStyleBas, nRadiusInterne, false);
				this.__BorderRadius(tabStyleBas, nRadiusInterne, false);
			}
		}
		if (this.m_oParametres.m_bRedimensionnementRendezVous)
		{
			tabStyleBas.push(["cursor:N-resize"]);
		}
		if (tabStyleBas.length)
		{
			this.__StyleCree(this.__sGetSelecteur(sClass, "", this.ms_sNomRDVRedimBas), tabStyleBas);
		}
		this.__StyleCree(this.__sGetSelecteur(undefined, "", sClass), tabStyle);
	}

	var nPadding = this.__nGetRendezVousEpaisseurBordure(oStyle);
	if (nPadding)
	{
		var tabStyle = ["padding-left:" + nPadding + "px", "padding-right:" + nPadding + "px"];
		// Si besoin ajoute un deplacement de l'image
		if (bIEQuirks && (8 > nIE))
		{
			tabStyle.push("-ms-background-position-x:" + nPadding + "px");
		}
		else
		{
			tabStyle.push("background-position-x:" + nPadding + "px");
		}
		this.__StyleCree(this.__sGetSelecteur(undefined, "", sClass + " td"), tabStyle);
	}
};

// Creation d'une feuille de style
WDPlanning.prototype.__oCreeFeuilleStyle = function __oCreeFeuilleStyle()
{
	// Creation de la feuille de style
	var oStyle = document.getElementsByTagName("head")[0].appendChild(document.createElement("style"));
	if (bWK)
	{
		oStyle.appendChild(document.createTextNode(""));
	}
	return oStyle.styleSheet ? oStyle.styleSheet : oStyle.sheet;
};

// Creation d'un style pour tout les champs planning
WDPlanning.prototype.__StyleCreeGlobal = function __StyleCreeGlobal(sNomStyle, tabStyle)
{
	CreeStyle(this.ms_oFeuilleStyleGlobale, sNomStyle, tabStyle.join(';'));
};

// Creation ou modification d'un style pour le champ courant
WDPlanning.prototype.__StyleCree = function __StyleCree(sNomStyle, tabStyle)
{
	// Supprime le style
	this.__StyleSupprime(sNomStyle);
	// Et le recree
	CreeStyle(this.m_oFeuilleStyle, sNomStyle, tabStyle.join(';'));
};

// Supprime un style
WDPlanning.prototype.__StyleSupprime = function __StyleSupprime(sNomStyle)
{
	var nStyle = this.__nStyleTrouve(sNomStyle);
	if (-1 != nStyle)
	{
		if (bIE)
		{
			this.m_oFeuilleStyle.removeRule(nStyle);
		}
		else
		{
			this.m_oFeuilleStyle.deleteRule(nStyle);
		}
	}
};

// Complete un style
WDPlanning.prototype.__StyleComplete = function __StyleComplete(sNomStyle, tabStyle)
{
	// Trouve le style
	var nStyle = this.__nStyleTrouve(sNomStyle);
	if (-1 != nStyle)
	{
		// Le modifie
		var i;
		var nLimiteI = tabStyle.length;
		for (i = 0; i < nLimiteI; i++)
		{
			var tabTemp = tabStyle[i].split(":");
			this.m_oFeuilleStyleRules[nStyle].style[tabTemp[0]] = tabTemp[1];
		}
	}
	else
	{
		// Non trouve : le cree
		CreeStyle(this.m_oFeuilleStyle, sNomStyle, tabStyle.join(';'));
	}
};

// Trouve un style
WDPlanning.prototype.__nStyleTrouve = function __nStyleTrouve(sNomStyle)
{
	// Recherche le style dans la feuille de style locale
	var tabRules = this.m_oFeuilleStyleRules;
	var i;
	var nLimiteI = tabRules.length;
	for (i = 0; i < nLimiteI; i++)
	{
		if (tabRules[i].selectorText == sNomStyle)
		{
			return i;
		}
	}

	// Non trouve
	return -1;
};

// Initialise les differents evenements
WDPlanning.prototype.__InitEvents = function __InitEvents()
{
	// Evenements :
	//	- Generiques :
	//		- Redimensionnement : fait pas le champ (appel de OnResize)
	//		- Defilement : rien a faire
	// => Vide
	//	- Specifiques :
	//		- Drag drop des rendez-vous
	this.m_oDragRendezVous = new WDDragRendezVous(this);
	this.m_oDragRendezVous.Init();
	//		- Drag-drop dans le fond d'une ressource (selection d'une periode pour creation d'un rendez-vous)
	this.m_oDragPeriodeSelect = new WDDragPeriodeSelect(this);
	this.m_oDragPeriodeSelect.Init();
	//		- Entree en saisie dans un champ
	this.m_oPopupSaisie = new WDPopupSaisiePlanning(this);
	this.m_oPopupSaisie.Init();
};

// Affiche le contenu
// bRAZ : indique s'il faut supprimer le precedent contenu
WDPlanning.prototype.__HTMLAfficheContenu = function __HTMLAfficheContenu(bRAZ)
{
	if (bRAZ)
	{
		this.__HTMLVideRendezVousSelection();
		this.__HTMLVideRendezVous();
		this.__HTMLVideCorps();
		this.__HTMLVideTitres();
	}


	// Construit la zone des titres (nom des ressources)
	this.__HTMLAfficheTitres();
	// Construit la zone des rendez vous
	this.__HTMLAfficheCorps();
	// Construit les rendez-vous
	this.__HTMLAfficheRendezVous();
	// Et affiche le rendez-vous selectionne
	this.__HTMLAfficheRendezVousSelection();

	// Declenche la synchronisation des scrolling (et des largeurs)
	this.nSetTimeoutUnique("OnScrollCorps", 1);

	// Sauve les parametres (pour avoir le tableau des anciens rendez-vous lors du reaffichage)
	this.m_oOldDonnees = this.m_oDonnees;
};

// Construit le HTML des ressource
WDPlanning.prototype.__HTMLAfficheTitres = function __HTMLAfficheTitres()
{
	// Genere la table
	var tabHTML = [];
	tabHTML.push("<table class=\"");
	tabHTML.push(this.ms_sNomTitre);
	tabHTML.push("\"><tr><td class=\"");
	tabHTML.push(this.ms_sNomColGauche);
	tabHTML.push("\">");
	this.__HTMLAfficheDiv(tabHTML, this.ms_sNomColGauche);
	tabHTML.push("</td>");

	var tabRessources = this.m_oDonnees.m_tabRessources;
	var i;
	var nLimiteI = tabRessources.length;
	for (i = 0; i < nLimiteI; i++)
	{
		tabHTML.push("<td class=\"");
		tabHTML.push(this.ms_sNomColRessource);
		if (i == 0)
		{
			tabHTML.push(" " + this.ms_sNomColRessourcePremier);
		}
		tabHTML.push("\" id=\"");
		tabHTML.push(this.sGetNomElement(this.sGetSuffixeIDElement(this.ms_sNomTitre, i)));
		tabHTML.push("\">");
		this.__HTMLAfficheDiv(tabHTML, this.ms_sNomColRessource + " " + this.m_oParametres.m_oStyleLibRessource.m_sClasses, undefined, clWDEncode.sEncodeInnerHTML(tabRessources[i].m_sNomAffiche, true, false));
		tabHTML.push("</td>");
	}
	tabHTML.push("</tr></table>");
	this.m_oHoteTitres.innerHTML = tabHTML.join("");
};

// Supprime le HTML des ressources
WDPlanning.prototype.__HTMLVideTitres = function __HTMLVideTitres()
{
	SupprimeFils(this.m_oHoteTitres);
};

// Construit la zone des rendez vous
WDPlanning.prototype.__HTMLAfficheCorps = function __HTMLAfficheCorps()
{
	var tabHTML = [];
	tabHTML.push("<table>");
	tabHTML.push("<tr class=\"");
	tabHTML.push(this.ms_sNomCorpsQuadrillage);
	tabHTML.push("\"><td colspan=\"");
	tabHTML.push(this.m_oDonnees.m_tabRessources.length + 1);
	tabHTML.push("\"><div class=\"");
	tabHTML.push(this.ms_sNomCorpsQuadrillage);
	tabHTML.push("\">");

	// Calcule les heures ouvrables (arrondi a l'heure pres)
	// => On corrige la valeur des parametres pour ne pas refaire le calcul partout
	var nHeureOuvrableMin = this.__nGetHeureArrondiDefaut(this.m_oParametres.m_nHeureOuvrableMin);
	this.m_oParametres.m_nHeureOuvrableMin = nHeureOuvrableMin * 3600000;
	var nHeureOuvrableMax = this.m_oParametres.m_nHeureOuvrableMax = this.__nGetHeureArrondiExces(this.m_oParametres.m_nHeureOuvrableMax);
	this.m_oParametres.m_nHeureOuvrableMax = nHeureOuvrableMax * 3600000;
	var nHeureAfficheMin = this.m_oParametres.m_nHeureAfficheMin = this.__nGetHeureArrondiDefaut(this.m_oParametres.m_nHeureAfficheMin);
	this.m_oParametres.m_nHeureAfficheMin = nHeureAfficheMin * 3600000;
	var nHeureAfficheMax = this.m_oParametres.m_nHeureAfficheMax = this.__nGetHeureArrondiExces(this.m_oParametres.m_nHeureAfficheMax);
	this.m_oParametres.m_nHeureAfficheMax = nHeureAfficheMax * 3600000;

	// Calcule aujourdhui
	var oAujourdhui = new Date();
	oAujourdhui.setUTCHours(0, 0, 0, 0);
	var nAjourdhui = oAujourdhui.getTime();
	// 86400000 = 24 * 3600 * 1000 = 1 jour en ms
	var nDemain = nAjourdhui + 86400000;

	// Pour facilite la conversion position => Date, on stocke l'heure de debut chaque bloc dans un tableau
	this.m_tabLigneHeure = [];

	var oHeure = new Date(this.m_oParametres.m_oDateDebut);
	oHeure.setUTCMinutes(0, 0, 0);

	// On construit en parallele les DIVs pour la couleur de fond et pour la couleur
	var tabHTMLFondCouleur = this.__tabHTMLAfficheCorpsHeureDebut(this.ms_sNomFondCouleur);
	var tabHTMLFondBordure = this.__tabHTMLAfficheCorpsHeureDebut(this.ms_sNomFondBordure);
	var tabHTMLFondRupture = this.__tabHTMLAfficheCorpsHeureDebut(this.ms_sNomFondRupture);

	// Commence a -1 car des le debut on va passer au jour suivant
	var nJour = -1;
	var oJour;
	// Si on trouve une heure dans aujourd'hui on l'affichera
	var nPositionAujourdhui = -1;

	var nNbHeuresVisibles = 0;
	var nDateDebutHeure;
	var nPosition = 0;
	for (; oHeure < this.m_oParametres.m_oDateFin; oHeure.setTime(nDateDebutHeure + 3600000))
	{
		var nDateDebutHeure = oHeure.getTime();
		var nHeure = oHeure.getUTCHours();

		// Teste si on change de jour et que l'on doit alors affiche une rupture de jour
		// Ou si on est sur la premiere ligne
		if ((0 == nHeure) || (nJour == -1))
		{
			nJour++;
			// Trouve la description du jour
			oJour = this.m_oParametres.m_tabJours[nJour];

			if (oJour.m_bAujourdhui)
			{
				nPositionAujourdhui = nPosition;
			}

			// Si on doit afficher la rupture de jour
			if (this.m_oParametres.m_nHauteurLibJour)
			{
				// La partie avec la couleur : dessous : div vide
				this.__HTMLAfficheDiv(tabHTMLFondCouleur, this.ms_sNomJour);
				// La partie avec les bordures : dessous : div vide
				this.__HTMLAfficheDiv(tabHTMLFondBordure, this.ms_sNomJour);
				// La partie avec les rupture : dessus
				tabHTMLFondRupture.push("<div class=\"");
				tabHTMLFondRupture.push(this.ms_sNomJour);
				tabHTMLFondRupture.push(" ");
				tabHTMLFondRupture.push(this.m_oParametres.m_oStyleLibJourSemaine.m_sClasses);
				tabHTMLFondRupture.push("\" style=\"top:");
				tabHTMLFondRupture.push(nPosition);
				// Ajoute un id pour les retrouver facilement lors du positionnement
				tabHTMLFondRupture.push("px\">");
				tabHTMLFondRupture.push(oJour.m_sLibelle);
				tabHTMLFondRupture.push("</div>");

				nPosition += this.m_oParametres.m_nHauteurLibJour;
			}
		}

		// Par defaut le style est celui d'une heure ouvrable
		var nStyle = 0;

		// Si l'heure n'est pas affichee
		if ((nHeure < nHeureAfficheMin) || (nHeure >= nHeureAfficheMax))
		{
			continue;
		}

		switch (oHeure.getDay())
		{
			case 6:
				// Samedi
				nStyle = 3;
				break;
			case 0:
				// Dimanche
				nStyle = 4;
				break;
		}

		// Si l'heure est non ouvrable
		if ((nHeure < nHeureOuvrableMin) || (nHeure >= nHeureOuvrableMax))
		{
			nStyle = 1;
		}
		// Si c'est un jour ferie
		if (oJour.m_bFerie)
		{
			nStyle = 5;
		}
		var tabClasseTypeHeure = [this.ms_sNomHeure];
		tabClasseTypeHeure.push("WDPLN-" + this.ms_tabHeureSuffixe[nStyle]);

		// Si on est dans aujourdhui
		if ((nDateDebutHeure >= nAjourdhui) && (nDateDebutHeure < nDemain))
		{
			tabClasseTypeHeure.push("WDPLN-" + this.ms_tabHeureSuffixe[2]);
		}
		var sClasseTypeHeure = tabClasseTypeHeure.join(" ");

		// Si on a un style d'heure non standard on reforce la couleur de fond
		var sCouleurFond = undefined;
		if (nStyle > 0)
		{
			sCouleurFond = this.m_oParametres["m_oStyle" + this.ms_tabHeureSuffixe[nStyle]].m_cFond;
		}

		// La partie avec la couleur : dessous
		this.__HTMLAfficheDiv(tabHTMLFondCouleur, sClasseTypeHeure, undefined, undefined, sCouleurFond);

		// La partie avec la bordure : dessus
		tabHTMLFondBordure.push("<div class=\"");
		tabHTMLFondBordure.push(sClasseTypeHeure);
		tabHTMLFondBordure.push("\">");
		this.__HTMLAfficheDiv(tabHTMLFondBordure, this.ms_sNomHeureDemi);
		tabHTMLFondBordure.push("<div class=\"");
		tabHTMLFondBordure.push(this.ms_sNomHeureLibelle);
		tabHTMLFondBordure.push(" ");
		tabHTMLFondBordure.push(this.m_oParametres.m_oStyleLibHeure.m_sClasses);
		tabHTMLFondBordure.push("\"><span class=\"");
		tabHTMLFondBordure.push(this.m_oParametres.m_oStyleLibHeure.m_sClasses);
		tabHTMLFondBordure.push("\">");
		tabHTMLFondBordure.push(this.__sHTMLAfficheFormateHeure(nHeure));
		tabHTMLFondBordure.push("</span></div></div>");

		this.m_tabLigneHeure.push({ m_nDateDebutHeure: nDateDebutHeure, m_nPosition: nPosition });

		nNbHeuresVisibles++;
		nPosition += this.m_oParametres.m_nHauteurHeure;
	}

	// Ferme les tableaux
	tabHTMLFondCouleur.push("</div>");
	tabHTMLFondBordure.push("</div>");
	tabHTMLFondRupture.push("</div>");
	// Et les fusionne avec le tableau global
	tabHTML = tabHTML.concat(tabHTMLFondCouleur);
	tabHTML = tabHTML.concat(tabHTMLFondBordure);
	tabHTML = tabHTML.concat(tabHTMLFondRupture);

	var nHauteurZoneHeures = nPosition;
	tabHTML.push("</div></td></tr><tr class=\"");
	tabHTML.push(this.ms_sNomCorpsHauteurTotale);
	tabHTML.push("\"><td class=\"");
	tabHTML.push(this.ms_sNomColGauche);
	tabHTML.push("\">");
	this.__HTMLAfficheDiv(tabHTML, this.ms_sNomColGauche + " " + this.ms_sNomColCouleur + " " + this.ms_sNomCorpsHauteurTotale);
	this.__HTMLAfficheDiv(tabHTML, this.ms_sNomColGauche + " " + this.ms_sNomCorpsHauteurTotale);
	tabHTML.push("</td>");

	// On ne peut calculer ce style que maintenant (que l'on a nHauteurZoneHeures)
	var tabStyle = ["height:" + nHauteurZoneHeures + "px"];
	this.__StyleComplete(this.__sGetSelecteur(undefined, "", this.ms_sNomCorpsHauteurTotale), ["height:" + nHauteurZoneHeures + "px"]);
	this.__StyleComplete(this.__sGetSelecteur(undefined, "", this.ms_sNomColRessourceConteneur), ["width:" + this.__nGetColLargeurRessources() + "px"]);

	var tabRessources = this.m_oDonnees.m_tabRessources;
	var i;
	var nLimiteI = tabRessources.length;
	for (i = 0; i < nLimiteI; i++)
	{
		tabHTML.push("<td class=\"");
		tabHTML.push(this.ms_sNomColRessource);
		if (i == 0)
		{
			tabHTML.push(" " + this.ms_sNomColRessourcePremier);
		}
		tabHTML.push("\">");
		this.__HTMLAfficheDiv(tabHTML, this.ms_sNomColRessource + " " + this.ms_sNomColCouleur + " " + this.ms_sNomCorpsHauteurTotale);
		this.__HTMLAfficheDiv(tabHTML, this.ms_sNomColRessourceConteneur + " " + this.ms_sNomCorpsHauteurTotale, this.sGetNomElement(this.sGetSuffixeIDElement(this.ms_sNomColRessource, i)));
		tabHTML.push("</td>");
	}
	tabHTML.push("</tr></table>");

	this.m_oHoteCorps.innerHTML = tabHTML.join("");

	// Gestion du clic sur les ressources
	for (i = 0; i < nLimiteI; i++)
	{
		tabRessources[i].m_oDiv = this.oGetElementById(document, this.sGetSuffixeIDElement(this.ms_sNomColRessource, i));
		this.m_oDragPeriodeSelect.InitElement(tabRessources[i], tabRessources[i].m_oDiv);
	}

	// Si on a une position existante pour la meme zone
	if ((this.m_nPositionVerticale !== undefined) && (this.m_nPositionVerticaleDate == oHeure.getTime()))
	{
		this.m_oHoteCorps.scrollTop = this.m_nPositionVerticale;
	}
	else
	{
		// Si possible se place sur aujourdhui
		if (-1 != nPositionAujourdhui)
		{
			this.m_oHoteCorps.scrollTop = nPositionAujourdhui;
		}
		else
		{
			this.m_oHoteCorps.scrollTop = 0;
		}
		this.m_nPositionVerticaleDate = oHeure.getTime();
	}
	// Reforce la position (si on va trop loin)
	this.m_nPositionVerticale = this.m_oHoteCorps.scrollTop;
};

// Formatage d'une heure pour affichage
WDPlanning.prototype.__sHTMLAfficheFormateHeure = function __sHTMLAfficheFormateHeure(nHeure)
{
	// Trouve l'heure qui correspond
	return this.m_oParametres.m_tabFormatHeure[nHeure];
};

// Construit un div simple (avec une class et un contenu optionnel)
// tabHTML est mdofie en sortie
WDPlanning.prototype.__HTMLAfficheDiv = function __HTMLAfficheDiv(tabHTML, sClass, sId, sContenu, sCouleurFond)
{
	tabHTML.push("<div");
	if (sClass)
	{
		tabHTML.push(" class=\"");
		tabHTML.push(sClass);
		tabHTML.push("\"");
	}
	if (sId)
	{
		tabHTML.push(" id=\"");
		tabHTML.push(sId);
		tabHTML.push("\"");
	}
	if (sCouleurFond)
	{
		tabHTML.push(" style=\"background-color:");
		tabHTML.push(sCouleurFond);
		tabHTML.push("\"");
	}
	tabHTML.push(">");
	if (sContenu && sContenu.length)
	{
		tabHTML.push(sContenu);
	}
	else if (bIEQuirks)
	{
		tabHTML.push("<!-- -->");
	}
	tabHTML.push("</div>");
};

// Construit le debut du HTML des zone de couleur
WDPlanning.prototype.__tabHTMLAfficheCorpsHeureDebut = function __tabHTMLAfficheCorpsHeureDebut(sClasse)
{
	// On construit en parallele les DIVs pour la couleur de fond et pour la couleur
	var tabHTML = [];

	tabHTML.push("<div class=\"");
	tabHTML.push(sClasse);
	tabHTML.push("\">");

	return tabHTML;
};

// Supprime le HTML du conteneur
WDPlanning.prototype.__HTMLVideCorps = function __HTMLVideCorps()
{
	// Libere le hook sur les ressources
	var tabRessources = this.m_oOldDonnees.m_tabRessources;
	var i;
	var nLimiteI = tabRessources.length;
	for (i = 0; i < nLimiteI; i++)
	{
		this.m_oDragPeriodeSelect.LibereElement(tabRessources[i], tabRessources[i].m_oDiv);
		tabRessources[i].m_oDiv = null;
		delete tabRessources[i].m_oDiv;
	}

	SupprimeFils(this.m_oHoteCorps);
};

// Construit les rendez-vous
WDPlanning.prototype.__HTMLAfficheRendezVous = function __HTMLAfficheRendezVous()
{
	// Le tableau des rendez-vous est trie (calcul sur le serveur)
	// On precalcule la superposition des rendez-vous
	// On recoit un tableau des rendez-vous par ressources
	var tabRessourceRendezVous = this.__tabGetRessourceRendezVous();

	// Affiche les rendez vous par ressources
	var tabRessource = this.m_oDonnees.m_tabRessources;
	var i;
	var nLimiteI = tabRessource.length;
	for (i = 0; i < nLimiteI; i++)
	{
		this.__HTMLAfficheRendezVousRessource(tabRessourceRendezVous, i);
	}
};

// Affiche les rendez vous d'une ressource
WDPlanning.prototype.__HTMLAfficheRendezVousRessource = function __HTMLAfficheRendezVousRessource(tabRessourceRendezVous, nRessource)
{
	// Trouve le conteneur de la ressource
	var oConteneur = this.oGetConteneurRessource(nRessource);
	// Recupere le tableau des rendez-vous pour la ressource
	var tabRendezVous = tabRessourceRendezVous[nRessource];

	// Alloue a chaque rendez-vous une colonne
	// Chaque element du tableau est un objet avec "m_nColonne" et "m_nNbColonnes"
	var tabRendezVousColonneInfo = this.__tabGetRendezVousColonneInfo(tabRendezVous);

	var i;
	var nLimiteI = tabRendezVous.length;
	for (i = 0; i < nLimiteI; i++)
	{
		// Affiche le rendez-vous
		this.__HTMLAfficheUnRendezVous(tabRendezVous[i], tabRendezVousColonneInfo[i], oConteneur);
	}
};

// Affiche un rendez-vous
WDPlanning.prototype.__HTMLAfficheUnRendezVous = function __HTMLAfficheUnRendezVous(oRendezVous, oColonneInfo, oConteneur)
{
	var nDateDebutAff = this.m_oParametres.m_oDateDebut.getTime();
	var nDateFinAff = this.m_oParametres.m_oDateFin.getTime();

	// Duree en ms depuis le debut de l'affichage et le debut du rendez-vous
	// => gere le cas du rendez-vous qui commence avant le debut de l'affichage
	var nDateDebut = Math.max(oRendezVous.m_oDateDebut.getTime(), nDateDebutAff);
	// => gere le cas d'un rendez-vous qui commence dans la zone non affichee
	nDateDebut = this.__nCorrigeDateHeure(nDateDebut, true);

	// Duree en ms entre le debut et la fin du rendez-vous
	// => gere le cas du rendez-vous qui fini apres la fin de l'affichage
	var nDateFin = Math.min(oRendezVous.m_oDateFin.getTime(), nDateFinAff);
	// => gere le cas d'un rendez-vous qui fini dans la zone non affichee
	nDateFin = this.__nCorrigeDateHeure(nDateFin, false);

	// Si le rendez-vous n'est pas visible on ne l'affiche pas
	// WinDev ne fait pas forcement pareil
	if (nDateFin <= nDateDebut)
	{
		return;
	}

	// Creation du div
	var oDiv = document.createElement("div");
	oDiv.style.position = "absolute";
	oDiv.style.zIndex = this.ms_nZIndexRendezVous;
	// Position en colonne
	var nLargeur = this.__nHTMLAfficheUnRendezVousLargeur(oDiv, oColonneInfo.m_nColonne, oColonneInfo.m_nNbColonnes);

	// 3600000 = 3600 * 1000 = 1 heure en ms
	var nHauteur = this.__nGetHauteurRendezVous(nDateFin, nDateDebut);
	oDiv.style.top = this.__nGetHautRendezVous(nDateDebut, nDateDebutAff) + "px";
	oDiv.style.height = nHauteur + "px";
	oDiv.id = this.sGetNomElement(this.sGetSuffixeIDElement(this.ms_sNomRendezVous, oRendezVous.m_sID));
	oDiv.className = this.ms_sNomRendezVousExterne;

	// Ajoute dans la ressource
	oDiv = oConteneur.appendChild(oDiv);
	// + son contenu
	oDiv.innerHTML = this.__sGetHTMLRendezVous(oRendezVous, nLargeur, nHauteur);
	// + les evenements sur le contenu
	this.__SetRendezVousEvenements(oRendezVous, oDiv);

	// Memorise le DIV dans le rendez-vous
	oRendezVous.m_oDiv = oDiv;
};

// Positionne un rendez-vous en largeur
WDPlanning.prototype.__nHTMLAfficheUnRendezVousLargeur = function __nHTMLAfficheUnRendezVousLargeur(oDiv, nColonne, nNbColonnes)
{
	// Selon le mode de superposition
	switch (this.m_oParametres.m_eModeSuperposition)
	{
	default:
	case this.ms_eSuperpositionCoteACote:
		return this.__nHTMLAfficheUnRendezVousLargeurCoteACote(oDiv, nColonne, nNbColonnes);
	case this.ms_eSuperpositionDecalage:
		return this.__nHTMLAfficheUnRendezVousLargeurDecalage(oDiv, nColonne, nNbColonnes);
	}
};

// Positionne un rendez-vous en largeur avec un affichage "cote a cote"
WDPlanning.prototype.__nHTMLAfficheUnRendezVousLargeurCoteACote = function __nHTMLAfficheUnRendezVousLargeurCoteACote(oDiv, nColonne, nNbColonnes)
{
	// La colonne ne gere pas l'espace a gauche et a droite
	var nLargeurColonne = (this.__nGetColLargeurRessources() - 6) / nNbColonnes;

	// Position en colonne
	if (bIEQuirks)
	{
		// La colonne gere deja l'espace a gauche et a droite via un padding
		var nLargeurColonnePourcentage = 100 / nNbColonnes;
		oDiv.style.left = (nColonne * nLargeurColonnePourcentage) + "%";
		oDiv.style.width = nLargeurColonnePourcentage + "%";
	}
	else
	{
		// + 1 : Padding gauche
		oDiv.style.left = (1 + nColonne * nLargeurColonne) + "px";
		// + 5 : Padding droit
		oDiv.style.right = (5 + (nNbColonnes - nColonne - 1) * nLargeurColonne) + "px";
	}
	return nLargeurColonne;
};

// Positionne un rendez-vous en largeur avec un affichage "decalage"
WDPlanning.prototype.__nHTMLAfficheUnRendezVousLargeurDecalage = function __nHTMLAfficheUnRendezVousLargeurDecalage(oDiv, nColonne, nNbColonnes)
{
	// Si il n'y a qu'une colonne : retrouve le calcul "cote a cote"
	if (1 == nNbColonnes)
	{
		return this.__nHTMLAfficheUnRendezVousLargeurCoteACote(oDiv, nColonne, nNbColonnes);
	}

	// On reserve 30% pour les decalage
	var nPourcentageDecalage = 30;
	var nColLargeurRessources = this.__nGetColLargeurRessources() - 6;
	var nLargeurZoneVide = Math.floor(nColLargeurRessources * nPourcentageDecalage / 100);
	var nLargeurZoneVideColonne = nLargeurZoneVide / (nNbColonnes - 1);

	// Position en colonne
	if (bIEQuirks)
	{
		oDiv.style.left = (nColonne * nLargeurZoneVideColonne) + "px";
		oDiv.style.width = (nColLargeurRessources - nLargeurZoneVide) + "px";
	}
	else
	{
		// + 1 : Padding gauche
		oDiv.style.left = (1 + nColonne * nLargeurZoneVideColonne) + "px";
		// + 5 : Padding droit
		// + 1 : Le bord droit est inclus
		oDiv.style.right = (5 + (nNbColonnes - nColonne - 1) * nLargeurZoneVideColonne) + "px";
	}
	return Math.floor(nColLargeurRessources - nLargeurZoneVide);
};

// Trouve l'epaisseur des cellules bordures d'un rendez-vous en fonction de l'epaisseur des bordures du style
WDPlanning.prototype.__nGetRendezVousEpaisseurBordure = function __nGetRendezVousEpaisseurBordure(oStyle)
{
	// Epaisseur des elements sur le bord de la table
	var nEpaisseur = 3;
	if (0 < oStyle.m_nBordureV)
	{
		return Math.max(0, nEpaisseur - oStyle.m_nBordureV);
	}
	else
	{
		return nEpaisseur;
	}

};

// Recupere le contenu HTML d'un rendez-vous
WDPlanning.prototype.__sGetHTMLRendezVous = function __sGetHTMLRendezVous(oRendezVous, nLargeur, nHauteur)
{
	var nEpaisseur = this.__nGetRendezVousEpaisseurBordure(this.m_oParametres.m_oStyleRendezVous);

	var tabHTML = [];
	// Creation de la table exterieure
	tabHTML.push("<table class=\"");
	tabHTML.push(this.ms_sNomRendezVous);
	tabHTML.push("\" style=\"width:");
	tabHTML.push(nLargeur);
	tabHTML.push("px;height:");
	tabHTML.push(nHauteur);
	tabHTML.push("px");
	if (oRendezVous.m_cBord)
	{
		tabHTML.push(";border-color:");
		tabHTML.push(oRendezVous.m_cBord);
	}
	if (oRendezVous.m_sBulle)
	{
		tabHTML.push("\" title=\"");
		tabHTML.push(clWDEncode.sEncodeCharset(oRendezVous.m_sBulle));
	}
	tabHTML.push("\"><tr><td");
	if (oRendezVous.m_cFondTitre || nEpaisseur)
	{
		tabHTML.push(" style=\"");
		if (nEpaisseur)
		{
			tabHTML.push("padding-top:");
			tabHTML.push(nEpaisseur);
		}
		if (oRendezVous.m_cFondTitre)
		{
			var bDegrade = false;
			if (oRendezVous.m_cBord || (0 < this.m_oParametres.m_oStyleRendezVous.m_nBordureV))
			{
				// Fond degrade dans tous les navigateurs autres que IE8- et chrome (qui dessine mal le degrade (pas de clipping sur le bord arrondi)
				if ((!bIE || (8 > nIE)) && !bCrm)
				{
					tabHTML.push(";");
					if (bFF)
					{
						tabHTML.push("-moz-box-shadow");
					}
					else if (bWK)
					{
						tabHTML.push("-webkit-box-shadow");
					}
					else
					{
						tabHTML.push("box-shadow");
					}
					tabHTML.push(": 0px 20px 10px -10px ");
					tabHTML.push(oRendezVous.m_cFondTitre);
					tabHTML.push(" inset");
					bDegrade = true;
				}
			}
			tabHTML.push(";background-color:");
			// Avec le degrade on inverse les couleurs (pour avoir un degrade dans le bon sens
			tabHTML.push(bDegrade ? oRendezVous.m_cBord : oRendezVous.m_cFondTitre);
			tabHTML.push(";");
		}

		tabHTML.push("\"");
	}
	tabHTML.push(" class=\"");
	tabHTML.push(this.ms_sNomRendezVousTitre);
	tabHTML.push(" ");
	tabHTML.push(this.m_oParametres.m_oStyleRendezVous.m_sClasses);
	tabHTML.push("\"><div style=\"width:");
	tabHTML.push(nLargeur - 6);
	tabHTML.push("px\">");
	if (oRendezVous.m_sTitre)
	{
		tabHTML.push(clWDEncode.sEncodeInnerHTML(oRendezVous.m_sTitre, true, false));
	}
	else
	{
		tabHTML.push("&nbsp;");
	}
	tabHTML.push("</div></td></tr><tr");
	if (oRendezVous.m_cFondContenu)
	{
		tabHTML.push(" style=\"background-color:");
		tabHTML.push(oRendezVous.m_cFondContenu);
		tabHTML.push(";\"");
	}
	tabHTML.push(" height=\"100%\"><td");
	var tabClasses = [];
	if (oRendezVous.m_sImage)
	{
		tabHTML.push(" style=\"background-image:url('");
		tabHTML.push(_WD_);
		tabHTML.push(oRendezVous.m_sImage);
		tabHTML.push("')\"");
		tabClasses.push(this.ms_sNomRendezVousImage);
	}
	if (oRendezVous.m_sContenu && this.m_oParametres.m_oStyleLibContenu.m_sClasses)
	{
		tabClasses.push(this.m_oParametres.m_oStyleLibContenu.m_sClasses);
	}
	if (0 < tabClasses.length)
	{
		tabHTML.push(" class=\"");
		tabHTML.push(tabClasses.join(" "));
		tabHTML.push("\"");
	}
	tabHTML.push(">");
	if (oRendezVous.m_sContenu)
	{
		tabHTML.push("<div style=\"width:");
		tabHTML.push(nLargeur - 6);
		tabHTML.push("px\">")
		tabHTML.push(clWDEncode.sEncodeInnerHTML(oRendezVous.m_sContenu, true, false));
		tabHTML.push("</div>");
	}
	tabHTML.push("</td></tr><tr");
	if (oRendezVous.m_cFondContenu)
	{
		tabHTML.push(" style=\"background-color:");
		tabHTML.push(oRendezVous.m_cFondContenu);
		tabHTML.push(";\"");
	}
	tabHTML.push("><td height=\"");
	tabHTML.push(nEpaisseur + 2);
	tabHTML.push("\" class=\"");
	tabHTML.push(this.ms_sNomRDVRedimBas);
	tabHTML.push("\"/><div style=\"width:");
	// On n'est pas exactement precis car il faudrait tenir compte de nEpaisseur mais celui-ci change avec la selection
	tabHTML.push(nLargeur - 6);
	tabHTML.push(";height:");
	tabHTML.push(nEpaisseur + 2);
	tabHTML.push("px\" class=\"");
	tabHTML.push(this.ms_sNomRDVRedimBas);
	tabHTML.push("\"/></div>");
	if (oRendezVous.m_bRepetee)
	{
		tabHTML.push("<img class=\"");
		tabHTML.push(this.ms_sNomRDVRepetition);
		tabHTML.push("\" src=\"");
		tabHTML.push(this.ms_sImageRepetition);
		tabHTML.push("\" />");
	}

	if (0 < oRendezVous.m_nImportance)
	{
		tabHTML.push("<img class=\"");
		tabHTML.push(this.ms_sNomRDVImportance);
		tabHTML.push("\" src=\"");
		tabHTML.push(this.ms_sImageImportance);
		tabHTML.push("\" />");
	}
	tabHTML.push("</tr></table>");
//	tabHTML.push("\" class=\"");
//	tabHTML.push(this.ms_sNomRDVRedimBas);
//	tabHTML.push("\"/></tr></table>");
	return tabHTML.join("");
};

// Fixe les evenements sur un rendez-vous
WDPlanning.prototype.__SetRendezVousEvenements = function __SetRendezVousEvenements(oRendezVous, oDiv)
{
	// Intercepte le :
	//						Rendez-vous		Page
	// Debut du drag-drop	mousedown
	// En drag-drop							mousemove
	// Fin du drag-drop						mouseup
	// Selection/Autres		onclick
	// Entree en saisie		ondblclick
	this.m_oDragRendezVous.InitElement(oRendezVous, oDiv)

	var oThis = this;
	var oThisRendezVous = oRendezVous;
	oRendezVous.m_fOnClick = function(oEvent) { oEvent = oEvent ? oEvent : event; return oThis.OnRendezVousClic(oEvent, oThisRendezVous); };
	oRendezVous.m_fOnDblClick = function(oEvent) { oEvent = oEvent ? oEvent : event; return oThis.OnRendezVousDoubleClic(oEvent, oThisRendezVous); };
	HookOnXXX(oDiv, 'onclick', 'click', oRendezVous.m_fOnClick);
	HookOnXXX(oDiv, 'ondblclick', 'dblclick', oRendezVous.m_fOnDblClick);
};

// Le tableau des rendez-vous est trie (calcul sur le serveur)
// On precalcule la superposition des rendez-vous
// On recoit un tableau des rendez-vous par ressources
WDPlanning.prototype.__tabGetRessourceRendezVous = function __tabGetRessourceRendezVous()
{
	var tabRessourceRendezVous = [];

	// Creation des tableaux internes
	var tabRessource = this.m_oDonnees.m_tabRessources;
	var i;
	var nLimiteI = tabRessource.length;
	for (i = 0; i < nLimiteI; i++)
	{
		tabRessourceRendezVous.push([]);
	}

	// Et remplissage avec les rendez-vous
	// Normalement tous les indices sont valides (le serveur ne retourne que les rendezvous associees a une ressource)
	// Et comme les rendez-vous sont deja trie, ils seront aussi tri une fois dans les ressources
	var tabRendezVous = this.m_oDonnees.m_tabRendezVous;
	nLimiteI = tabRendezVous.length;
	for (i = 0; i < nLimiteI; i++)
	{
		var oRendezVous = tabRendezVous[i];
		tabRessourceRendezVous[oRendezVous.m_nRessource].push(oRendezVous);
	}

	return tabRessourceRendezVous;
};

// Alloue a chaque rendez-vous une colonne
WDPlanning.prototype.__tabGetRendezVousColonneInfo = function __tabGetRendezVousColonneInfo(tabRendezVous)
{
	var nNbRendezVous = tabRendezVous.length;
	// Le tableau avec le resultat
	var tabRendezVousColonneInfo = new Array(nNbRendezVous);

	// Le tableaux de l'etat des colonnes
	var tabColonnes = [];

	// Pour la detection du nombre de colonne :
	// Le nombre de colonne ne change pas tant qu'il y a un rendez-vous affiche sur une colonne.
	// Donc on detecte le debut d'un zone ou toutes les colonnes sont vides
	var nDebutZone = 0;

	// Alloue a chaque rendez-vous une colonne
	var i;
	for (i = 0; i < nNbRendezVous; i++)
	{
		var oRendezVous = tabRendezVous[i];

		// Si on n'a aucune colonne d'utilise (cas apres l'init, on ne passe pas dans la boucle mais la valeur est deja bonne)
		var nPremiereColonneLibre = tabColonnes.length;
		var nNbColonnesLibres = 0;

		// Met a jour le contenu des colonnes (et supprime les colonnes inutiles)
		var j;
		for (j = tabColonnes.length - 1; j >= 0; j--)
		{
			// Si le rendez-vous existe et est fini
			if (tabColonnes[j] && (tabColonnes[j].m_oDateFin <= oRendezVous.m_oDateDebut))
			{
				// La colonne n'est plus utilise
				tabColonnes[j] = null;
			}
			// Si la colonne est vide
			if (!tabColonnes[j])
			{
				// => MAJ de nPremiereColonneLibre (comme on fait un parcours a l'envers la valeur sera bonne a la fin de la boucle)
				nPremiereColonneLibre = j;
				nNbColonnesLibres++;
			}
		}

		// Cree l'objet et note la colonne
		tabRendezVousColonneInfo[i] = new Object();
		tabRendezVousColonneInfo[i].m_nColonne = nPremiereColonneLibre;

		// Si toutes le colonnes sont vides
		if (tabColonnes.length == nNbColonnesLibres)
		{
			// Note le nombre de colonnes dans tous les rendez-vous depuis le dernier RAZ
			// (incremente nDebutZone au passage)
			for (; nDebutZone < i; nDebutZone++)
			{
				tabRendezVousColonneInfo[nDebutZone].m_nNbColonnes = tabColonnes.length;
			}
			// Puis repart a zero
			tabColonnes.length = 0;
//			nDebutZone = i + 1;
		}

		// Place le rendez-vous dans la premiere colonne vide
		if (nPremiereColonneLibre == tabColonnes.length)
		{
			tabColonnes.push(oRendezVous);
		}
		else
		{
			tabColonnes[nPremiereColonneLibre] = oRendezVous;
		}
	}

	// Note le nombre de colonnes dans tous les rendez-vous depuis le dernier RAZ
	for (; nDebutZone < i; nDebutZone++)
	{
		tabRendezVousColonneInfo[nDebutZone].m_nNbColonnes = tabColonnes.length;
	}

	return tabRendezVousColonneInfo;
};

// Supprime le HTML des rendez-vous
WDPlanning.prototype.__HTMLVideRendezVous = function __HTMLVideRendezVous()
{
	// Utilise le tableau des rendez-vous precedents
	var tabRendezVous = this.m_oOldDonnees.m_tabRendezVous;
	var i;
	var nLimiteI = tabRendezVous.length;
	for (i = 0; i < nLimiteI; i++)
	{
		// Supprime le rendez-vous
		this.__HTMLVideUnRendezVous(tabRendezVous[i]);
	}
};

// Supprime le HTML d'un rendez-vous
WDPlanning.prototype.__HTMLVideUnRendezVous = function __HTMLVideUnRendezVous(oRendezVous)
{
	// Supprime les evenements
	var oDiv = oRendezVous.m_oDiv;
	if (oDiv)
	{
		// Supprime les evenements
		UnhookOnXXX(oDiv, 'ondblclick', 'dblclick', oRendezVous.m_fOnDblClick);
		oRendezVous.m_fOnDblClick = null;
		delete oRendezVous.m_fOnDblClick;
		UnhookOnXXX(oDiv, 'onclick', 'click', oRendezVous.m_fOnClick);
		oRendezVous.m_fOnClick = null;
		delete oRendezVous.m_fOnClick;
		this.m_oDragRendezVous.LibereElement(oRendezVous, oDiv);

		// Puis supprime le div du HTML
		oDiv.parentNode.removeChild(oDiv);
		// Puis supprime la reference
		oDiv = null;
		oRendezVous.m_oDiv = null;
		delete oRendezVous.m_oDiv;
	}
};

// Modifie l'epaisseur des cellules bordures d'un rendez-vous
WDPlanning.prototype.__HTMLAfficheRendezVousCellulesBordures = function __HTMLAfficheRendezVousCellulesBordures(oRendezVous, oTableRendezVous, oStyle, oStyleContenu)
{
	var tabCellules = oTableRendezVous.getElementsByTagName("td");
	// Epaisseur des bordures : elle change avec le style : il faut changer les tailles des cellules
	if (this.m_oParametres.m_oStyleRendezVous.m_nBordureV != this.m_oParametres.m_oStyleRendezVousSelect.m_nBordureV)
	{
		// Epaisseur des elements sur le bord de la table
		var nEpaisseur = this.__nGetRendezVousEpaisseurBordure(oStyle);

		tabCellules[0].style.paddingTop = nEpaisseur + "px";
		tabCellules[2].height = nEpaisseur + 2;
	}

	// Change la classe du texte
	tabCellules[0].className = this.ms_sNomRendezVousTitre + " " + oStyle.m_sClasses;
	// Si on a un contenu
	var tabClasses = [];
	if (oRendezVous.m_sImage)
	{
		tabClasses.push(this.ms_sNomRendezVousImage);
	}
	if (oRendezVous.m_sContenu && oStyleContenu.m_sClasses)
	{
		tabClasses.push(oStyleContenu.m_sClasses);
	}
	tabCellules[1].className = tabClasses.join(" ");
};

// Affiche les elements specifique au rendez-vous selectionne
WDPlanning.prototype.__HTMLAfficheRendezVousSelection = function __HTMLAfficheRendezVousSelection()
{
	// Si un element est selectionne
	if (this.m_oRendezVousSelection)
	{
		// Affiche le bouton de suppression
		this.__HTMLAfficheRendezVousSuppression(this.m_oRendezVousSelection);

		var oDiv = this.m_oRendezVousSelection.m_oDiv;
		var oTable = oDiv.firstChild;
		// Style du rendez-vous
		oTable.className = this.ms_sNomRendezVousSelect;
		oDiv.style.zIndex = this.ms_nZIndexRendezVousSelection;
		// Epaisseur des bordures : elle change avec le style : il faut changer les tailles des cellules
		this.__HTMLAfficheRendezVousCellulesBordures(this.m_oRendezVousSelection, oTable, this.m_oParametres.m_oStyleRendezVousSelect, this.m_oParametres.m_oStyleLibContenuSelect);

		// Entre en saisie
		if (this.m_oParametres.m_bEditTitreRDVSelection)
		{
			this.m_oParametres.m_bEditTitreRDVSelection = false;
			this.OnRendezVousDoubleClic(null, this.m_oRendezVousSelection);
		}
	}
};

// Supprime les elements specifiques au rendez-vous selectionne
WDPlanning.prototype.__HTMLVideRendezVousSelection = function __HTMLVideRendezVousSelection(bRAZ)
{
	// Il faut valider le div aussi car si on est en reception traitement AJAX, m_oRendezVousSelection
	// contient deja le nouveau rendez-vous qui n'est pas encore liee a son DIV
	if (this.m_oRendezVousSelection && this.m_oRendezVousSelection.m_oDiv)
	{
		var oDiv = this.m_oRendezVousSelection.m_oDiv;
		var oTable = oDiv.firstChild;
		// Epaisseur des bordures : elle change avec le style : il faut changer les tailles des cellules
		this.__HTMLAfficheRendezVousCellulesBordures(this.m_oRendezVousSelection, oTable, this.m_oParametres.m_oStyleRendezVous, this.m_oParametres.m_oStyleLibContenu);
		// Style du rendez-vous
		oDiv.style.zIndex = this.ms_nZIndexRendezVous;
		oTable.className = this.ms_sNomRendezVous;
	}

	// Masque le bouton de suppression
	this.__HTMLVideRendezVousSuppression();
};

// Affiche le bouton de suppression
WDPlanning.prototype.__HTMLAfficheRendezVousSuppression = function __HTMLAfficheRendezVousSuppression(oRendezVous)
{
	// Si le bouton existe : le supprime
	this.__HTMLVideRendezVousSuppression();

	// On n'affiche pas le bouton si l'utilisateur n'a pas le droit de supprimer
	if (this.m_oParametres.m_bSupprimeParUtilisateur)
	{
		// Trouve le parent d'ajout : le td racine de la colonne (pour avoir le rendez-vous au dessus de tout)
		var oDiv = oRendezVous.m_oDiv;
		var oParent = oDiv.parentNode.parentNode;

		// Et le (re)cree
		var oRendezVousSuppression = document.createElement("img");
		oRendezVousSuppression.src = this.ms_sImageSupprime;
		oRendezVousSuppression.className = this.ms_sNomRendezVousSupprime;

		oRendezVousSuppression.style.top = (oDiv.offsetTop - 6 + oParent.offsetTop) + "px";
		// En mode quirks, il y a le padding en plus
		oRendezVousSuppression.style.left = (oDiv.offsetLeft + oDiv.offsetWidth - 8 - (bIEQuirks ? 5 : 0) + oParent.offsetLeft) + "px";
		this.m_oRendezVousSuppression = oParent.appendChild(oRendezVousSuppression);

		// Ajoute l'evenement
		HookOnXXX(this.m_oRendezVousSuppression, 'onclick', 'click', this.m_fOnRendezVousSupprime);
	}
};

// Masque le bouton de suppression
WDPlanning.prototype.__HTMLVideRendezVousSuppression = function __HTMLVideRendezVousSuppression()
{
	// Supprime l'evenement sur le bouton s'il existe
	if (this.m_oRendezVousSuppression)
	{
		UnhookOnXXX(this.m_oRendezVousSuppression, 'onclick', 'click', this.m_fOnRendezVousSupprime);
	}
	// Si le bouton existe : le supprime
	bHTMLVideDepuisVariable(this, "m_oRendezVousSuppression");
};

// Touve le conteneur des rendez-vous d'une ressource
WDPlanning.prototype.oGetConteneurRessource = function oGetConteneurRessource(nRessource)
{
	return this.oGetIDElement(this.ms_sNomColRessource, nRessource);
};

// Recupere la ressource en fonction de la position
// nRessourcePrecedente : ressource "actuelle"/par defaut
// => valeur retournee si on n'est pas dans une ressource
// => valeur recherche en premier (valeur la plus probable : accelere le calcul
WDPlanning.prototype.nGetRessourceDepuisPosition = function nGetRessourceDepuisPosition(oEvent, nRessourcePrecedente)
{
	var oOriginalTarget = clWDUtil.oGetOriginalTarget(oEvent);

	// Si on n'a pas change de ressource
	if (bEstFils(oOriginalTarget, this.oGetConteneurRessource(nRessourcePrecedente), document))
	{
		return nRessourcePrecedente;
	}

	// On n'est plus dans la meme ressource : trouve la nouvelle ressource
	var tabRessource = this.m_oDonnees.m_tabRessources;
	var i;
	var nLimiteI = tabRessource.length;
	for (i = 0; i < nLimiteI; i++)
	{
		if (bEstFils(oOriginalTarget, this.oGetConteneurRessource(i), document))
		{
			return i;
		}
	}

	// Non trouve (on est hors de la zone des ressource
	return nRessourcePrecedente;
};

// Recupere la largeur du style d'une colonne
WDPlanning.prototype.__nGetColLargeur = function __nGetColLargeur(oCol, oStyle)
{
	var nLargeur = oCol.m_nLargeur;
	if (0 < oStyle.m_nBordureV)
	{
		// - * 1 et pas - * 2 pour firefox et ie
		return nLargeur - (bIEQuirks ? 0 : oStyle.m_nBordureV);
	}
	return nLargeur;
};

// Recupere la largeur du style d'une colonne de ressource
WDPlanning.prototype.__nGetColLargeurRessources = function __nGetColLargeurRessources(oStyle)
{
	return this.__nGetColLargeur(this.m_oParametres.m_oColRessource, this.m_oParametres.m_oStyleNormal);
};

// - Tous les champs : Notifie le champ le conteneur xxx est affiche via un .display = "block"
WDPlanning.prototype.OnDisplay = function OnDisplay(oElementRacine)
{
	// Appel de la methode de la classe de base
	WDChampParametres.prototype.OnDisplay.apply(this, arguments);

	if (this.m_oHote && bEstFils(this.m_oHote, oElementRacine, document))
	{
		// Reaffiche le contenu du champ
		this.__Reinit();
	}
};

// - Tous les champs : Notifie le champ que la fenetre est redimentionnee
WDPlanning.prototype.OnResize = function OnResize(oEvent)
{
	// Appel de la methode de la classe de base
	WDChampParametres.prototype.OnResize.apply(this, arguments);

	if (this.m_oHote)
	{
		// Reaffiche le contenu du champ
		this.__Reinit();
	}
};


// Defilement de la zone d'affichage
WDPlanning.prototype.OnScrollCorps = function OnScrollCorps(oEvent)
{
	// Ajoute la largeur de la zone des titres
	var nLargeurCorpsClient = this.m_oHoteCorps.clientWidth;
	if (nLargeurCorpsClient != this.m_oHoteTitres.clientWidth)
	{
		this.m_oHoteTitres.style.width = nLargeurCorpsClient + "px";
	}

	// Synchronise les scrolls
	var nScrollCorps = this.m_oHoteCorps.scrollLeft;
	if (nScrollCorps != this.m_oHoteTitres.scrollLeft)
	{
		this.m_oHoteTitres.scrollLeft = nScrollCorps;
	}

	// Memorise la position pour le cas d'un reaffichage
	var nPositionVerticale = this.m_nPositionVerticale;
	this.m_nPositionVerticale = this.m_oHoteCorps.scrollTop;
	// Memorise la position pour le serveur dans le champ formulaire la selection
	if (nPositionVerticale != this.m_nPositionVerticale)
	{
		this.ConstruitParam();
	}

	var tabStyleModif = [];

	// Change la largeur si besoin
	var nLargeurLibJour = this.nGetLargeurLibJour(nLargeurCorpsClient, this.__nGetOffsetLibJour());
	if (nLargeurLibJour != this.m_nLargeurLibJour)
	{
		this.m_nLargeurLibJour = nLargeurLibJour;
		tabStyleModif.push("width:" + nLargeurLibJour + "px");
	}

	if (nScrollCorps != this.m_nScrollCorps)
	{
		this.m_nScrollCorps = nScrollCorps;
		tabStyleModif.push("left:" + this.m_nScrollCorps + "px");
	}

	if (tabStyleModif.length)
	{
		this.__StyleComplete(this.__sGetSelecteur(undefined, "", this.ms_sNomJour), tabStyleModif);
	}
};

// Liaison entre les parametres et la selection
WDPlanning.prototype.__TrouveSelection = function __TrouveSelection()
{
	// Supprime le rendez-vous selectionne actuel (s'il n'est pas affiche il n'existe pas)
	this.m_oRendezVousSelection = null;
	delete this.m_oRendezVousSelection;

	// Trouve le rendez-vous selectionne
	if (this.m_oParametres.m_sIDSelection !== undefined)
	{
		var tabRendezVous = this.m_oDonnees.m_tabRendezVous;
		var i;
		var nLimiteI = tabRendezVous.length;
		for (i = 0; i < nLimiteI; i++)
		{
			if (tabRendezVous[i].m_sID == this.m_oParametres.m_sIDSelection)
			{
				this.m_oRendezVousSelection = tabRendezVous[i];
				break;
			}
		}
	}
};

// Applique les parametres
WDPlanning.prototype._vAppliqueParametres = function vAppliqueParametres()
{
	WDChampParametres.prototype._vAppliqueParametres.apply(this, arguments);

	// Recharge le champ (en particulier le calcul tailles etc)
	this.__Reinit(true);

	// Pour le mode AWP on refixe dans le champ formulaire la selection
	this.ConstruitParam();
};

// Pour implementer ConstruitParam (accepte des parametres variables)
WDPlanning.prototype._vsConstruitParam = function _vsConstruitParam()
{
	var tabParam = [];
	// Appel de la methode de la classe de base
	var sParam = WDChampParametres.prototype._vsConstruitParam.apply(this, arguments);
	if (sParam.length > 0)
	{
		tabParam.push(sParam);
	}

	// Ajoute la position du debut du champ
	tabParam.push(this.m_oParametres.m_oDateDebut.getTime() + "");
	// Ajoute la position de scrolling
	if (this.m_nPositionVerticale)
	{
		var oLigneHeure = this.__oGetLigneHeure(this.m_nPositionVerticale);
		var oDateDebutVertical = new Date(oLigneHeure.m_nDateDebutHeure);
		oDateDebutVertical.setUTCHours(0, 0, 0, 0);
		// Si on est en fait sur la rupture du jour suivant
		if (this.m_nPositionVerticale >= (oLigneHeure.m_nPosition + this.m_oParametres.m_nHauteurHeure))
		{
			var nHauteurSiJourSuivant = oLigneHeure.m_nPosition + this.m_oParametres.m_nHauteurHeure + this.m_oParametres.m_nHauteurTitre;
			if (this.m_nPositionVerticale < nHauteurSiJourSuivant)
			{
				var oLigneHeure2 = this.__oGetLigneHeure(nHauteurSiJourSuivant);
				var oDateDebutVertical2 = new Date(oLigneHeure2.m_nDateDebutHeure);
				oDateDebutVertical2.setUTCHours(0, 0, 0, 0);
				if ((oLigneHeure2.m_nPosition == nHauteurSiJourSuivant) && (oDateDebutVertical2.getDate() == (oDateDebutVertical.getDate() + 1)))
				{
					oDateDebutVertical = oDateDebutVertical2;
				}
			}
		}
		tabParam.push(oDateDebutVertical.getTime() + "");
	}
	else
	{
		tabParam.push(this.m_oParametres.m_oDateDebut.getTime() + "");
	}

	// Si on a recu un argument : c'est le rendez-vous
	var oRendezVous = (arguments.length >= 1) ? arguments[0] : this.m_oRendezVousSelection;

	// Les details du rendez-vous (au format urlencode)
	if (oRendezVous)
	{
		tabParam.push(this._sConstruitParamObjet(oRendezVous));
	}
	else
	{
		tabParam.push("");
	}

	return tabParam.join(',');
};

// Recupere la largeur totale de la zone cible
WDPlanning.prototype.__nGetLargeur = function __nGetLargeur()
{
	return this._nGetOffsetWidth(this.m_oHote);
};

// Recupere la hauteur totale de la zone cible
WDPlanning.prototype.__nGetHauteur = function __nGetHauteur()
{
	return this._nGetOffsetHeight(this.m_oHote);
};

// Recupere la hauteur totale de la zone du corps (cas vertical
WDPlanning.prototype.__nGetHauteurCorps = function __nGetHauteurCorps()
{
	return this.__nGetHauteur() - this.m_oParametres.m_nHauteurTitre;
};

// Recupere la partie heure dans une journee une heure arrondie par defaut
// DD/MM/AAAA HH:MM:SS:MMM => HH:00:00:000
WDPlanning.prototype.__nGetHeureArrondiDefaut = function __nGetHeureArrondiDefaut(nHeure)
{
	// 3600000 = 3600 * 1000 = 1 heure en ms
	return Math.floor(nHeure / 3600000);
};

// Recupere la partie heure dans une journee une heure arrondie par defaut
// DD/MM/AAAA HH:MM:SS:MMM => HH:00:00:000 (si MM = SS = MMM = 0) ou HH+1:00:00:000
WDPlanning.prototype.__nGetHeureArrondiExces = function __nGetHeureArrondiExces(nHeure)
{
	// 3600000 = 3600 * 1000 = 1 heure en ms
	return Math.ceil(nHeure / 3600000);
};

// Recupere la partie heure (dans la journee) dans une date
// DD/MM/AAAA HH:MM:SS:MMM => HH:MM:SS:MMM (en ms depuis 00:00)
WDPlanning.prototype.__nGetHeureJour = function __nGetHeureJour(nDate)
{
	var oTemp = new Date(nDate);
	oTemp.setUTCHours(0, 0, 0, 0);
	return nDate - oTemp.getTime();
};

// Corrige une heure pour etre dans la plage des heures affichables
// bSensFuture : Si vrai on arrondi en priorite la date vers le futur
WDPlanning.prototype.__nCorrigeDateHeure = function __nCorrigeDateHeure(nDate, bSensFutur)
{
	var nHeureJour = this.__nGetHeureJour(nDate);
	if (nHeureJour < this.m_oParametres.m_nHeureAfficheMin)
	{
		// Si on est le matin : avant l'heure min
		if (bSensFutur)
		{
			// Avance la date
			return nDate - nHeureJour + this.m_oParametres.m_nHeureAfficheMin;
		}
		else
		{
			// Recule la date au jour precedent
			// 86400000 = 24 * 3600 * 1000 = 1 jour en ms
			return nDate - nHeureJour - 86400000 + this.m_oParametres.m_nHeureAfficheMax;
		}
	}
	else if (nHeureJour >= this.m_oParametres.m_nHeureAfficheMax)
	{
		// Si on est le soir : apres l'heure max
		if (bSensFutur)
		{
			// Avance la date au jour suivant
			// 86400000 = 24 * 3600 * 1000 = 1 jour en ms
			return nDate - nHeureJour + 86400000 + this.m_oParametres.m_nHeureAfficheMin;
		}
		else
		{
			// Recule la date
			return nDate - nHeureJour + this.m_oParametres.m_nHeureAfficheMax;
		}
	}
	return nDate;
};

// Calcule la position en pixel du haut d'un rendezvous
WDPlanning.prototype.__nGetHautRendezVous = function __nGetHautRendezVous(nDate, nDateReference)
{
	return this.__nGetHauteurDepuisDifferenceDate(nDate, nDateReference, true);
};

// Calcule la hauteur en pixel d'un rendezvous
WDPlanning.prototype.__nGetHauteurRendezVous = function __nGetHauteurRendezVous(nDate, nDateReference)
{
	var nHauteur = this.__nGetHauteurDepuisDifferenceDate(nDate, nDateReference, false);

	// Ce calcul est deje fait par __nGetHauteurDepuisDifferenceDate maintenant
//	// Corrige pour les heures non affiche que traverse le rendez-vous
//	// Normalement les heures recues sont valide car deja corrige par __nCorrigeDateHeure
//	var nJour = Math.floor(nDate / 86400000);
//	var nJourReference = Math.floor(nDateReference / 86400000);
//	if (nJour != nJourReference)
//	{
//		// Calcule le nombre d'heure non affiche par jour
//		// this.m_oParametres.m_nHeureAfficheMax : est le DEBUT de la derniere heure
//		var nMsNonAffiche = 86400000 - (this.m_oParametres.m_nHeureAfficheMax + 3600000) + this.m_oParametres.m_nHeureAfficheMin;
//		nHauteur -= nMsNonAffiche * this.m_oParametres.m_nHauteurHeure / 3600000;
//	}

	return nHauteur;
};

// Calcule la position en pixel d'une date donnee par rapport a une autre
// nDate doit etre une date dans la plage valide
// bDepuisDebut : indique que l'on compare a la date de debut. il faut le savoir car on a alors une rupture de plus (la premiere)
// mais elle n'apparait pas dans le calcul de nOffsetJour
WDPlanning.prototype.__nGetHauteurDepuisDifferenceDate = function __nGetHauteurDepuisDifferenceDate(nDate, nDateReference, bDepuisDebut)
{
	// Calcule la duree depuis le debut de l'affichage
	var nOffsetMs = nDate - nDateReference;

	// Corrige pour les zones non affichees
	// => Commence par corriger en nombres de jours
	var nOffsetJour = Math.floor((nDate - nDateReference) / 86400000);
	nOffsetMs -= nOffsetJour * (this.m_oParametres.m_nHeureAfficheMin + 86400000 - this.m_oParametres.m_nHeureAfficheMax);
	nDateReference += nOffsetJour * 86400000;
	// => Puis corrige pour le dernier jour
	var nHeureJourReference = this.__nGetHeureJour(nDateReference);
	if (nHeureJourReference < this.m_oParametres.m_nHeureAfficheMin)
	{
		nOffsetMs -= this.m_oParametres.m_nHeureAfficheMin - nHeureJourReference;
		nOffsetJour--;
	}
	else if (nHeureJourReference >= this.m_oParametres.m_nHeureAfficheMax)
	{
		nOffsetMs -= this.m_oParametres.m_nHeureAfficheMin + nHeureJourReference - this.m_oParametres.m_nHeureAfficheMax;
		nOffsetJour--;
	}

	// Et retourne la valeur selon la hauteur d'une heure
	var nHauteur = nOffsetMs * this.m_oParametres.m_nHauteurHeure / 3600000;
	// Compense pour les ruptures
	if (this.m_oParametres.m_nHauteurLibJour)
	{
		nHauteur += (nOffsetJour + (bDepuisDebut ? 1 : 0)) * this.m_oParametres.m_nHauteurLibJour;
	}
	return nHauteur;
};

// Recupere la description de l'heure dans lequel le point se trouve
WDPlanning.prototype.__oGetLigneHeure = function __oGetLigneHeure(nPosition)
{
	// Calcule la position en nombre d'heures depuis le debut de l'affichage => on obtient donc l'heure de debut de la zone
	// Normalement cette heure est aligne sur la resolution
	var nHeureLigneNumero = Math.floor(nPosition / this.m_oParametres.m_nHauteurHeure);
	nHeureLigneNumero = Math.min(nHeureLigneNumero, this.m_tabLigneHeure.length - 1);
	// A cause des ruptures de ligne, trouve l'heure exacte qui est forcement apres car les ruptures decalent vers le bas
	// Le calcul est fait pour avoir une valeur valide en cas de clic sur une rupture
	var oLigneHeure;
	do
	{
		oLigneHeure = this.m_tabLigneHeure[nHeureLigneNumero];
		nHeureLigneNumero--;

	} while ((nHeureLigneNumero >= 0) && (oLigneHeure.m_nPosition > nPosition))

	return oLigneHeure;
};

// Trouve la position en point par rapport au debut de l'heure
WDPlanning.prototype.__nGetPositionDansHeure = function __nGetPositionDansHeure(nPosition, oLigneHeure)
{
	// Calcule la difference de position
	var nPositionDansHeure = nPosition - oLigneHeure.m_nPosition;
	// Si on est sur la premiere rupture : nPositionDansHeure < 0
	nPositionDansHeure = Math.max(nPositionDansHeure, 0);
	// Si on est sur une autre rupture : nPositionDansHeure > this.m_oParametres.m_nHauteurHeure
	nPositionDansHeure = Math.min(nPositionDansHeure, this.m_oParametres.m_nHauteurHeure);

	return nPositionDansHeure;
};

// Convertie une nouvelle position (deja aligne sur la resolution) en date
WDPlanning.prototype.__oGetDateFromPosAlignResolution = function __oGetDateFromPosAlignResolution(nPosition)
{
	// Trouve la date (verifiant la resulution) la plus proche de la position donnee

	// A cause des ruptures de ligne, trouve l'heure exacte qui est forcement apres car les ruptures decalent vers le bas
	var oLigneHeure = this.__oGetLigneHeure(nPosition);

	// Trouve la position en point par rapport au debut de l'heure
	var nPositionDansHeure = this.__nGetPositionDansHeure(nPosition, oLigneHeure);
	// En deduit la date
	var nDatePosition = oLigneHeure.m_nDateDebutHeure + nPositionDansHeure * 3600000 / this.m_oParametres.m_nHauteurHeure;
	// Et construit l'objet date
	return new Date(parseInt(nDatePosition, 10));
};

// Donne le pas de resolution minimum
WDPlanning.prototype.dGetResolutionPx = function dGetResolutionPx()
{
	return this.m_oParametres.m_nHauteurHeure * this.m_oParametres.m_nResolution / 3600000;
};
WDPlanning.prototype.nGetResolutionPx = function nGetResolutionPx(dResolutionPx)
{
	return Math.round(dResolutionPx);
};

// Arrondi la variation en fonction de la granularite autorisee
WDPlanning.prototype.nAppliqueResolution = function nAppliqueResolution(nPosition, dResolutionPx)
{
	// A cause des ruptures de ligne, trouve l'heure exacte qui est forcement apres car les ruptures decalent vers le bas
	var oLigneHeure = this.__oGetLigneHeure(nPosition);

	// Trouve la position (corrigee) en point par rapport au debut de l'heure
	var nPositionDansHeure = this.__nGetPositionDansHeure(nPosition, oLigneHeure);

	// Arrondi la position en fonction de la granularite autorisee
	var nOffetNbResolution = Math.round(nPositionDansHeure / dResolutionPx);
	return oLigneHeure.m_nPosition + Math.round(nOffetNbResolution * dResolutionPx);
};

// Nom d'une ressource par index
WDPlanning.prototype.sGetNomRessource = function sGetNomRessource(nRessource)
{
	return this.m_oDonnees.m_tabRessources[nRessource].m_sNomAffiche;
};

// Indique si si deux rendez-vous sont indentiques
WDPlanning.prototype.__bMemeRendezVous = function __bMemeRendezVous(oRendezVous1, oRendezVous2)
{
	// Compare :
	// - Les pointeurs (rapide)
	// - Les IDs (lent) pour le cas ou c'est le meme rendez-vous mais retourne par le serveur
	return ((oRendezVous1 == oRendezVous2) || (oRendezVous1 && oRendezVous2 && (oRendezVous1.m_sID == oRendezVous2.m_sID)));
};

// Selectionne une rendez-vous
WDPlanning.prototype.bOnRendezVousSelection = function bOnRendezVousSelection(oEvent, oRendezVous)
{
	// Si deja selectionne
	if (this.__bMemeRendezVous(this.m_oRendezVousSelection, oRendezVous))
	{
		// Reforce la selection (pour le cas ou les pointeurs sont differents)
		this.m_oRendezVousSelection = oRendezVous;
		return true;
	}

	// Valide avec le PCode (+ construit les parametres)
	if (!this.__bAppelPCodeConstruitParam(this.ms_nEventNavAgendaRdvSelection, undefined, oEvent, oRendezVous))
	{
		return false;
	}

	// Le rendez-vous selectionne ne l'est plus
	this.__HTMLVideRendezVousSelection();

	// Memorise la selection
	this.m_oRendezVousSelection = oRendezVous;

	// Affiche le nouveau rendez-vous selectionne
	this.__HTMLAfficheRendezVousSelection();

	return true;
};

// Clic sur un rendez-vous
WDPlanning.prototype.OnRendezVousClic = function OnRendezVousClic(oEvent, oRendezVous)
{
	// Selectionne le rendez-vous
	this.bOnRendezVousSelection(oEvent, oRendezVous);
};

// Double clic sur un rendez-vous
WDPlanning.prototype.OnRendezVousDoubleClic = function OnRendezVousDoubleClic(oEvent, oRendezVous)
{
	// Valide que l'on a le droit d'edition
	if (this.m_oParametres.m_bEditionRendezVous)
	{
		// Valide avec le PCode (le rendez-vous est normalement deja selectionne par le clic)
		if (this.__bAppelPCode(this.ms_nEventNavAgendaRdvEdition, undefined, oEvent, oRendezVous))
		{
			// Entre en saisie
			this.m_oPopupSaisie.Debut(oRendezVous.m_oDiv, 0, oRendezVous);
		}
	}
};

// Fin de la modification d'un rendez-vous (= fin du double clic)
WDPlanning.prototype.OnRendezVousValideSaisie = function OnRendezVousValideSaisie(oEvent, oRendezVous, sValeur)
{
	var sOldTitre = oRendezVous.m_sTitre;
	// Uniquement si la valeur change (pas d'appel serveur inutile)
	if (sValeur != sOldTitre)
	{
		oRendezVous.m_sTitre = sValeur;

		// Valide avec le PCode (le rendez-vous est normalement deja selectionne par le clic)
		if (!this.__bAppelPCodeConstruitParam(this.ms_nEventNavAgendaRdvModifTitre, this.ms_sActionAgendaRdvModifTitre, oEvent, oRendezVous))
		{
			// Refus de la modification
			oRendezVous.m_sTitre = sOldTitre;
		}
	}
};

// Notifie du redimensionnement de la selection
WDPlanning.prototype.OnRendezVousRedimensionne = function OnRendezVousRedimensionne(oEvent, nTop, nHauteur)
{
	this.__bOnRendezVousDeplacement(oEvent, nTop, nHauteur);
};

// Notifie du deplacement (et/ou du changement de ressources)
WDPlanning.prototype.OnRendezVousDeplacement = function OnRendezVousDeplacement(oEvent, nTop, nHauteur, nRessource)
{
	this.__bOnRendezVousDeplacement(oEvent, nTop, nHauteur, nRessource);
};

// Notifie du deplacement/redimensionnement (et/ou du changement de ressources)
// nRessource != undefined => Deplacement (meme si la ressource ne change pas
WDPlanning.prototype.__bOnRendezVousDeplacement = function __bOnRendezVousDeplacement(oEvent, nTop, nHauteur, nRessource)
{
	var oRendezVous = this.oGetRendezVousSelection();

	// Calcule la nouvelle position du rendez-vous
	var oOldDateDebut = oRendezVous.m_oDateDebut;
	var oOldDateFin = oRendezVous.m_oDateFin;
	var nOldRessource = oRendezVous.m_nRessource;
	oRendezVous.m_oDateDebut = this.__oGetDateFromPosAlignResolution(nTop);
	oRendezVous.m_oDateFin = this.__oGetDateFromPosAlignResolution(nTop + nHauteur);

	var nPCode;
	var sAction;
	if (nRessource !== undefined)
	{
		// Deplacement
		nPCode = this.ms_nEventNavAgendaRdvDeplacement;
		sAction = this.ms_sActionAgendaRdvDeplacement;

		// Si il y a changement de ressource
		if (nRessource != oRendezVous.m_nRessource)
		{
			oRendezVous.m_nRessource = nRessource;
			if (!this.__bAppelPCode(this.ms_nEventNavPlanningRdvDeplacementRessource, undefined, oEvent, oRendezVous))
			{
				oRendezVous.m_oDateDebut = oOldDateDebut;
				oRendezVous.m_oDateFin = oOldDateFin;
				oRendezVous.m_nRessource = nOldRessource;
				return false;
			}
		}
	}
	else
	{
		// Redimensionnement
		nPCode = this.ms_nEventNavAgendaRdvRedim;
		sAction = this.ms_sActionAgendaRdvRedim;
	}

	// Valide avec le PCode
	if (!this.__bAppelPCodeConstruitParam(nPCode, sAction, oEvent, oRendezVous))
	{
		oRendezVous.m_oDateDebut = oOldDateDebut;
		oRendezVous.m_oDateFin = oOldDateFin;
		if (nRessource !== undefined)
		{
			oRendezVous.m_nRessource = nOldRessource;
		}
		return false;
	}
	return true;
};

// Notifie de la selection
WDPlanning.prototype.bOnPeriodeSelect = function bOnPeriodeSelect(oEvent, nTop, nHauteur, nRessource)
{
	// @@@ Place les valeurs pour le code navigateur
//	...

	// Appel le code navigateur
	if (!this.__bAppelPCode(this.ms_nEventNavAgendaPeriodeSelect, undefined, oEvent))
	{
		// @@@ Retablie les valeurs originales
//		...
		return false;
	}

	return true;
};

// Ajoute un rendez-vous a la position de la selection
WDPlanning.prototype.OnRendezVousAjoute = function OnRendezVousAjoute(oEvent, nTop, nHauteur, nRessource)
{
	// Creation du rendez-vous
	var oRendezVous = new Object();
	oRendezVous.m_nRessource = nRessource;
	oRendezVous.m_oDateDebut = this.__oGetDateFromPosAlignResolution(nTop);
	oRendezVous.m_oDateFin = this.__oGetDateFromPosAlignResolution(nTop + nHauteur);
	oRendezVous.m_sTitre = "";
	oRendezVous.m_sContenu = "";

	// Appel le code navigateur
	this.__bAppelPCodeConstruitParam(this.ms_nEventNavAgendaRdvAjoute, this.ms_sActionAgendaRdvAjoute, oEvent, oRendezVous);
};

// Supprime le rendez-vous selectionn
WDPlanning.prototype.OnRendezVousSupprime = function OnRendezVousSupprime(oEvent)
{
	// Appel le code navigateur
	var oRendezVous = this.oGetRendezVousSelection();
	this.__bAppelPCodeConstruitParam(this.ms_nEventNavAgendaRdvSupprime, this.ms_sActionAgendaRdvSupprime, oEvent, oRendezVous);
};

// Lit le rendez-vous selectionne
WDPlanning.prototype.oGetRendezVousSelection = function oGetRendezVousSelection(oRendezVous)
{
	return this.m_oRendezVousSelection;
};

// Appel d'un PCode navigateur avec transmission d'un rendezvous + creation des parametres serveurs
WDPlanning.prototype.__bAppelPCodeConstruitParam = function __bAppelPCodeConstruitParam(ePCodeNav, sActionServeur, oEvent, oRendezVous)
{
	// Construit les parametres pour le serveur
	if (oRendezVous)
	{
		this.ConstruitParam(oRendezVous);
	}
	else
	{
		this.ConstruitParam();
	}

	return this.__bAppelPCode(ePCodeNav, sActionServeur, oEvent, oRendezVous);
};

// Appel d'un PCode navigateur avec transmission (optionnelle) d'un rendezvous
WDPlanning.prototype.__bAppelPCode = function __bAppelPCode(ePCodeNav, sActionServeur, oEvent, oRendezVous)
{
	// Si on a un rendezvous, construit le type avance correspondant et le transmet au PCode
	var oRes = this.RecuperePCode(ePCodeNav)(oEvent, sActionServeur, oRendezVous ? new WDRendezVous(this, oRendezVous) : undefined);
	// Aucun retour ou Retour = (exactement) true
	if ((oRes === undefined) || (oRes === true))
	{
		return true;
	}
	// Retour = (exactement) false
	if (oRes === false)
	{
		return true;
	}
	// Sinon comparaison souple
	return (oRes != false);
};

// Le gestionnaire de dragdrop pour le champ planning : gestion des ressources et d'un fantome
function WDDragPlanning (nDelaiAvantDeplacement, nDelaiEntreDeplacement, oChampPlanning)
{
	// Si on est pas dans l'init d'un protoype
	if (nDelaiAvantDeplacement !== undefined)
	{
		// Appel le constructeur de la classe de base
		WDDrag.prototype.constructor.apply(this, [nDelaiAvantDeplacement, nDelaiEntreDeplacement]);

		// Sauve l'objet attache
		this.m_oChampPlanning = oChampPlanning;
	}
};

// Declare l'heritage
WDDragPlanning.prototype = new WDDrag();
// Surcharge le constructeur qui a ete efface
WDDragPlanning.prototype.constructor = WDDragPlanning;

// Initialisation
WDDragPlanning.prototype.Init = function Init()
{
	// Appel de la methode de la classe de base
	WDDrag.prototype.Init.apply(this, arguments);
};

// Gestion pour un element
WDDragPlanning.prototype.InitElement = function InitElement(oElement, oDiv)
{
	// Intercepte le mousedown sur le rendez-vous
	var oThis = this;
	var oElementLocal = oElement;
	oElement.m_fMouseDown = function(oEvent) { oEvent = oEvent ? oEvent : event; oThis.OnMouseDown.apply(oThis, [oEvent, oElementLocal]); return oThis._bStopPropagation(oEvent); };
	HookOnXXX(oDiv, 'onmousedown', 'mousedown', oElement.m_fMouseDown);
};
WDDragPlanning.prototype.LibereElement = function LibereElement(oElement, oDiv)
{
	// Supprime l'evenement mousedown sur le rendez-vous
	UnhookOnXXX(oDiv, 'onmousedown', 'mousedown', oElement.m_fMouseDown);
	oElement.m_fMouseDown = null;
	delete oElement.m_fMouseDown;
};

// Appel lors du debut d'un clic pour le deplacement
// Pose les hooks
WDDragPlanning.prototype._vbOnMouseDown = function _vbOnMouseDown(oEvent)
{
	// Pas de drag-drop si on est en saisie
	if (this.m_oChampPlanning.m_oPopupSaisie.m_oRendezVous)
	{
		return false;
	}

	// Appel de la classe de base : sauve la position de la souris et place les hooks
	if (!WDDrag.prototype._vbOnMouseDown.apply(this, arguments))
	{
		return false;
	}

	// Suppression du fantome : on est sur de ne plus avoir un ancien fantome
	this.__FantomeSupprime();

	return true;
};

// Appel lors du deplacement de la souris
WDDragPlanning.prototype._vOnMouseMove = function _vOnMouseMove(oEvent)
{
	// Appel de la classe de base
	WDDrag.prototype._vOnMouseMove.apply(this, arguments);

	// Creation du fantome (si besoin)
	if (!this.m_oDivFantome)
	{
		// _vbFantomeCree est redefinie dans les classes derivees et transmet les parametres a _FantomeCree
		if (!this._vbFantomeCree(oEvent))
		{
			return;
		}
	}
	// Deplacement du fantome
	// _vbFantomeDeplace est redefinie dans les classes derivees et transmet les parametres a _bFantomeDeplace
	this._vbFantomeDeplace(oEvent);
};

// Appel lors du relachement de la souris
WDDragPlanning.prototype._vOnMouseUp = function _vOnMouseUp(oEvent)
{
	// Si besoin il faut que la fonction dans la classe derivee fasse une derniere MAJ du Fantome
//	this._vbFantomeDeplace(oEvent);

	// Suppression du fantome
	this.__FantomeSupprime();

	// Appel de la classe de base
	WDDrag.prototype._vOnMouseUp.apply(this, arguments);
};

// Creation du fantome (a redefinir)
WDDragPlanning.prototype._vbFantomeCree = function _vbFantomeCree(oEvent)
{
	// Appel de _FantomeCree dans les derivees
	return true;
};

// Creation du fantome
WDDragPlanning.prototype._FantomeCree = function _FantomeCree(nTop, nHauteur, nRessource, sCouleur)
{
	if (!this.m_oDivFantome)
	{
		// Creation du fantome
		var oDivFantome = document.createElement("div");
		oDivFantome.style.position = "absolute";
		// Positionne le fantome :
		// - En largeur pour prendre toute la largeur
		this.m_oChampPlanning.__nHTMLAfficheUnRendezVousLargeur(oDivFantome, 0, 1);
		// - En hauteur au meme endroit que le rendez-vous
		this.m_nDivFantomeTop = nTop
		oDivFantome.style.top = nTop + "px";
		this.m_nDivFantomeHeight = nHauteur;
		oDivFantome.style.height = nHauteur + "px";
		oDivFantome.style.backgroundColor = sCouleur ? sCouleur : "#cccccc";
		oDivFantome.style.opacity = _JCPO(60, oDivFantome);

		this.m_oDivFantome = this.m_oChampPlanning.oGetConteneurRessource(nRessource).appendChild(oDivFantome);
		this.m_nDivFantomeRessource = nRessource;
	}
};

// Deplacement du fantome
WDDragPlanning.prototype._vbFantomeDeplace = function _vbFantomeDeplace(oEvent)
{
	// Appel de _bFantomeDeplace dans les derivees
	return true;
};

// Deplacement du fantome
WDDragPlanning.prototype._bFantomeDeplace = function _bFantomeDeplace(nTop, nHauteur, nRessource)
{
	// Si le fantome n'a jamais ete cree (simple clic sans mouvement)
	if (!this.m_oDivFantome)
	{
		return false;
	}

	this.m_oDivFantome.style.top = nTop + "px";
	this.m_oDivFantome.style.height = nHauteur + "px";

	// Changement de conteneur si besoin
	if (this.m_nDivFantomeRessource != nRessource)
	{
		this.m_oDivFantome = this.m_oDivFantome.parentNode.removeChild(this.m_oDivFantome);
		this.m_oDivFantome = this.m_oChampPlanning.oGetConteneurRessource(nRessource).appendChild(this.m_oDivFantome);
		this.m_nDivFantomeRessource = nRessource;
	}

	return true;
};

// Suppression du fantome
WDDragPlanning.prototype.__FantomeSupprime = function __FantomeSupprime()
{
	if (bHTMLVideDepuisVariable(this, "m_oDivFantome"))
	{
		delete this.m_nDivFantomeRessource;
		delete this.m_nDivFantomeHeight;
		delete this.m_nDivFantomeTop;
	}
};

// Le gestionnaire de dragdrop des rendez-vous
function WDDragRendezVous(oChampPlanning)
{
	// Si on est pas dans l'init d'un protoype
	if (oChampPlanning)
	{
		// Appel le constructeur de la classe de base
		WDDragPlanning.prototype.constructor.apply(this, [250, 50, oChampPlanning]);
	}
};

// Declare l'heritage
WDDragRendezVous.prototype = new WDDragPlanning();
// Surcharge le constructeur qui a ete efface
WDDragRendezVous.prototype.constructor = WDDragRendezVous;

// Initialisation
WDDragRendezVous.prototype.Init = function Init()
{
	// Appel de la methode de la classe de base
	WDDragPlanning.prototype.Init.apply(this, arguments);
};

// Appel lors du debut d'un clic pour le deplacement
// Pose les hooks
WDDragRendezVous.prototype._vbOnMouseDown = function _vbOnMouseDown(oEvent, oRendezVous)
{
	// Appel de la classe de base : sauve la position de la souris et place les hooks
	if (!WDDragPlanning.prototype._vbOnMouseDown.apply(this, [oEvent]))
	{
		return false;
	}

	// Selectionne le rendez-vous
	var bRes = this.m_oChampPlanning.bOnRendezVousSelection(oEvent, oRendezVous);
	if (bRes)
	{
		// Determine si on est en deplacement ou en redimensionnement
		this.m_eDragMode = this.__eGetDragMode(oEvent, oRendezVous);
		// Verifie si l'action est autorise
		switch (this.m_eDragMode)
		{
//		case this.ms_eDragRedimHaut:
		case this.ms_eDragRedimBas:
			bRes = this.m_oChampPlanning.m_oParametres.m_bRedimensionnementRendezVous;
			break;
		case this.ms_eDragDrop:
		default:
			bRes = this.m_oChampPlanning.m_oParametres.m_bDeplacementRendezVous;
			break;
		}
	}

	// Si on doit annuler
	if (!bRes)
	{
		delete this.m_eDragMode;
		// Annule la selection
		this.OnMouseUp(oEvent);

		return false;
	}

	return true;
};

// Determine si on est en deplacement ou en redimensionnement
WDDragRendezVous.prototype.__eGetDragMode = function __eGetDragMode(oEvent, oRendezVous)
{
	// Seln la classe de l'element clique
	var oSource = clWDUtil.oGetOriginalTarget(oEvent);
	if (oSource)
	{
		switch (oSource.className)
		{
//		case this.m_oChampPlanning.ms_sNomRDVRedimHaut:
//			return this.ms_eDragRedimHaut;
		case this.m_oChampPlanning.ms_sNomRDVRedimBas:
			return this.ms_eDragRedimBas;
		}
	}
	return this.ms_eDragDrop;
};

// Appel lors du deplacement de la souris
WDDragRendezVous.prototype._vOnMouseMove = function _vOnMouseMove(oEvent)
{
	// Appel de la classe de base
	WDDragPlanning.prototype._vOnMouseMove.apply(this, arguments);
};

// Appel lors du relachement de la souris
WDDragRendezVous.prototype._vOnMouseUp = function _vOnMouseUp(oEvent)
{
	if (this.m_nDateMouseDown !== undefined)
	{
		// C'est un clic rapide : ne fait rien
	}
	else
	{
		// Dernier deplacement du fantome
		if (this._vbFantomeDeplace(oEvent))
		{
			// C'est un clic "lent" : drag-drop : effectue le deplacement
			this.__Deplacement(oEvent);
		}
	}

	delete this.m_eDragMode;

	// Appel de la classe de base
	WDDragPlanning.prototype._vOnMouseUp.apply(this, arguments);
};

// Effectue le deplacement
WDDragRendezVous.prototype.__Deplacement = function __Deplacement(oEvent)
{
	var nTop = this.m_oDivFantome.offsetTop;
	var nHauteur = this.m_oDivFantome.offsetHeight;
	var nRessource = this.m_nDivFantomeRessource;

	switch (this.m_eDragMode)
	{
//	case this.ms_eDragRedimHaut:
	case this.ms_eDragRedimBas:
		// Notifie du redimensionnement de la selection
		this.m_oChampPlanning.OnRendezVousRedimensionne(oEvent, nTop, nHauteur)
		break;
	case this.ms_eDragDrop:
	default:
		// Notifie du deplacement (et/ou du changement de ressources)
		this.m_oChampPlanning.OnRendezVousDeplacement(oEvent, nTop, nHauteur, nRessource)
		break;
	}
};

// Creation du fantome (a redefinir)
WDDragRendezVous.prototype._vbFantomeCree = function _vbFantomeCree(oEvent)
{
	// Appel _FantomeCree avec les bons parametres
	var oRendezVous = this.m_oChampPlanning.oGetRendezVousSelection();
	var oRendezVousDiv = oRendezVous.m_oDiv;
	this._FantomeCree(oRendezVousDiv.offsetTop, oRendezVousDiv.offsetHeight, oRendezVous.m_nRessource, oRendezVous.m_cFond);

	return true;
};

// Deplacement du fantome
WDDragRendezVous.prototype._vbFantomeDeplace = function _vbFantomeDeplace(oEvent)
{
	var oChampPlanning = this.m_oChampPlanning;

	var nTop = this.m_nDivFantomeTop;
	var nHauteur = this.m_nDivFantomeHeight;
	var nRessource = this.m_nDivFantomeRessource;

	// Arrondi la variation en fonction de la granularite autorisee
	var nOffSetPosY = this.nGetOffSetPosY(oEvent);
	var nBas = nTop + nHauteur;
	var dResolutionPx = oChampPlanning.dGetResolutionPx();
	var nResolutionPx = oChampPlanning.nGetResolutionPx(dResolutionPx);

	// Selon le mode de redimensionnement
	switch (this.m_eDragMode)
	{
//	case this.ms_eDragRedimHaut:
//		// Aligne le haut
//		nTop = oChampPlanning.nAppliqueResolution(nTop + nOffSetPosY, dResolutionPx);
//		// Si la variation arrondie de la hauteur donne une haute arrondie
//		if (nTop >= nBas)
//		{
//			nTop = oChampPlanning.nAppliqueResolution(nBas, dResolutionPx);
//			if (nTop >= nBas)
//			{
//				nTop -= nResolutionPx;
//			}
//		}
//		nHauteur = nBas - nTop;
//		break;
	case this.ms_eDragRedimBas:
		nBas = oChampPlanning.nAppliqueResolution(nBas + nOffSetPosY, dResolutionPx);
		// Si la variation de hauteur (arrondie) est negative
		if (nTop >= nBas)
		{
			nBas = oChampPlanning.nAppliqueResolution(nTop, dResolutionPx);
			if (nBas <= nTop)
			{
				nBas += nResolutionPx;
			}
		}
		nHauteur = nBas - nTop;
		break;
	case this.ms_eDragDrop:
	default:
		nTop = oChampPlanning.nAppliqueResolution(nTop + nOffSetPosY, dResolutionPx);
		nHauteur = oChampPlanning.nAppliqueResolution(nTop + nHauteur, dResolutionPx) - nTop;
		if (nHauteur <= 0)
		{
			nHauteur = nResolutionPx;
		}

		// Changement de ressource ?
		nRessource = oChampPlanning.nGetRessourceDepuisPosition(oEvent, nRessource);
		break;
	}

	// Appel de _bFantomeDeplace pour effectue l'affichage
	return this._bFantomeDeplace(nTop, nHauteur, nRessource);
};

// Le gestionnaire de selection d'une periode pour la creation d'un rendez-vous
function WDDragPeriodeSelect(oChampPlanning)
{
	// Si on est pas dans l'init d'un protoype
	if (oChampPlanning)
	{
		// Appel le constructeur de la classe de base
		// 200 : Pour ne pas appeler le PCode en boucle
		WDDragPlanning.prototype.constructor.apply(this, [0, 200, oChampPlanning]);
	}
};

// Declare l'heritage
WDDragPeriodeSelect.prototype = new WDDragPlanning();
// Surcharge le constructeur qui a ete efface
WDDragPeriodeSelect.prototype.constructor = WDDragRendezVous;

// Initialisation
WDDragPeriodeSelect.prototype.Init = function Init()
{
	// Appel de la methode de la classe de base
	WDDragPlanning.prototype.Init.apply(this, arguments);
};

// Stoppe la propagation sauf si on est en edition de champ
WDDragPeriodeSelect.prototype._vbStopPropagation = function _vbStopPropagation()
{
	return !this.m_oChampPlanning.m_oParametres.m_bSelectionPeriode;
};

// Appel lors du debut d'un clic pour le deplacement
// Pose les hooks
WDDragPeriodeSelect.prototype._vbOnMouseDown = function _vbOnMouseDown(oEvent, oRessource)
{
	// Si on clic sur un rendez-vous ne fait rien
	var oSource = clWDUtil.oGetOriginalTarget(oEvent);
	if (oSource != this.m_oChampPlanning.oGetConteneurRessource(oRessource.m_nRessource))
	{
		return false;
	}

	// Valide que l'on a le droit de selectionner une periode
	if (!this.m_oChampPlanning.m_oParametres.m_bSelectionPeriode)
	{
		return false;
	}

	// Appel de la classe de base : sauve la position de la souris et place les hooks
	if (!WDDragPlanning.prototype._vbOnMouseDown.apply(this, [oEvent]))
	{
		return false;
	}

	// Calcule la position initiale du fantome
	var oPosition = this.__oGetPositionFantome(oEvent, oRessource);
	// Lancement de la selection
	if (!this.m_oChampPlanning.bOnPeriodeSelect(oEvent, oPosition.m_nTop, oPosition.m_nHauteur, oRessource.m_nRessource))
	{
		// Annule la selection
		this.OnMouseUp(oEvent);
		return false;
	}

	this.m_oRessource = oRessource;
	return true;
};

// Appel lors du deplacement de la souris
WDDragPeriodeSelect.prototype._vOnMouseMove = function _vOnMouseMove(oEvent)
{
	// Appel de la classe de base
	WDDragPlanning.prototype._vOnMouseMove.apply(this, arguments);
};

// Appel lors du relachement de la souris
WDDragPeriodeSelect.prototype._vOnMouseUp = function _vOnMouseUp(oEvent)
{
	// Dernier deplacement du fantome
	if (this._vbFantomeDeplace(oEvent))
	{
		// C'est un clic "lent" : drag-drop : effectue le deplacement
		this.__Creation(oEvent);
	}

	delete this.m_oRessource;

	// Appel de la classe de base
	WDDragPlanning.prototype._vOnMouseUp.apply(this, arguments);
};

// Effectue la creation
WDDragPeriodeSelect.prototype.__Creation = function __Creation(oEvent)
{
	// Calcule la position du fantome (en double entre l'appel de _vbFantomeDeplace de _vOnMouseUp)
	var oPosition = this.__oGetPositionFantome(oEvent, this.m_oRessource);
	// Lancement de la creation
	this.m_oChampPlanning.OnRendezVousAjoute(oEvent, oPosition.m_nTop, oPosition.m_nHauteur, this.m_oRessource.m_nRessource);
};

// Creation du fantome (a redefinir)
WDDragPeriodeSelect.prototype._vbFantomeCree = function _vbFantomeCree(oEvent)
{
	// Calcule la position du fantome
	var oPosition = this.__oGetPositionFantome(oEvent, this.m_oRessource);
	// Lancement de la selection
	if (!this.m_oChampPlanning.bOnPeriodeSelect(oEvent, oPosition.m_nTop, oPosition.m_nHauteur, this.m_oRessource.m_nRessource))
	{
		// Annule la selection
		this.OnMouseUp(oEvent);
		return false;
	}

	// Appel _FantomeCree avec les bons parametres
	this._FantomeCree(oPosition.m_nTop, oPosition.m_nHauteur, this.m_oRessource.m_nRessource, this.m_oChampPlanning.m_oParametres.m_oStyleSelection.m_cFond);
	return true;
};

// Deplacement du fantome
WDDragPeriodeSelect.prototype._vbFantomeDeplace = function _vbFantomeDeplace(oEvent)
{
	// Calcule la position du fantome
	var oPosition = this.__oGetPositionFantome(oEvent, this.m_oRessource);
	// Lancement de la selection
	if (!this.m_oChampPlanning.bOnPeriodeSelect(oEvent, oPosition.m_nTop, oPosition.m_nHauteur, this.m_oRessource.m_nRessource))
	{
		// Annule la selection
		this.OnMouseUp(oEvent);
		return false;
	}

	// Appel _bFantomeDeplace avec les bons parametres
	return this._bFantomeDeplace(oPosition.m_nTop, oPosition.m_nHauteur, this.m_oRessource.m_nRessource);
};

// Calcule la position du fantome
// retourne un objet avec m_nTop et m_nHauteur
WDDragPeriodeSelect.prototype.__oGetPositionFantome = function __oGetPositionFantome(oEvent, oRessource)
{
	var oChampPlanning = this.m_oChampPlanning;
	var dResolutionPx = oChampPlanning.dGetResolutionPx();
	var nResolutionPx = oChampPlanning.nGetResolutionPx(dResolutionPx);

	// Recupere le dragdrop actuel
	var nPosY = _JCCP(this.nGetPosY(), oRessource.m_oDiv, false, false) + oChampPlanning.m_oHoteCorps.scrollTop;
	var nOffsetY = this.nGetOffSetPosY(oEvent);

	// Inverse la position si besoin pour avoir des coordonnees positives
	if (nOffsetY < 0)
	{
		nPosY = nPosY + nOffsetY;
		nOffsetY = -nOffsetY;
	}

	// Calcule la position du haut
	var nTop = this.__nGetTopResolutionDefaut(nPosY, dResolutionPx, nResolutionPx);
	// Et du bas
	var nHauteur = this.__nGetTopResolutionDefaut(nPosY + nOffsetY, dResolutionPx, nResolutionPx) - nTop;
	if ((nHauteur < nOffsetY + (nPosY - nTop)) || (0 == nHauteur))
	{
		nHauteur += nResolutionPx;
	}

	var oResultat = new Object();
	oResultat.m_nTop = nTop;
	oResultat.m_nHauteur = nHauteur;
	return oResultat;
};

// Recupere le haut du fantome
WDDragPeriodeSelect.prototype.__nGetTopResolutionDefaut = function __nGetTopResolutionDefaut(nTop, dResolutionPx, nResolutionPx)
{
	// Calcule la position du fantome
	var nTopResolutionDefaut = this.m_oChampPlanning.nAppliqueResolution(nTop, dResolutionPx);
	if (nTopResolutionDefaut > nTop)
	{
		nTopResolutionDefaut -= nResolutionPx;
	}
	return nTopResolutionDefaut;
};

// Objet pour la recherche dans une colonne
function WDPopupSaisiePlanning(oObjetParent)
{
	// Si on est pas dans l'init d'un protoype
	if (oObjetParent)
	{
		// Appel le constructeur de la classe de base
		WDPopupSaisie.prototype.constructor.apply(this, [oObjetParent, true]);
	}
};

// Declare l'heritage
WDPopupSaisiePlanning.prototype = new WDPopupSaisie();
// Surcharge le constructeur qui a ete efface
WDPopupSaisiePlanning.prototype.constructor = WDPopupSaisiePlanning;

// Initialisation
WDPopupSaisiePlanning.prototype.Init = function Init()
{
	// Appel de la methode de la classe de base
	WDPopupSaisie.prototype.Init.apply(this, arguments);
};

// Debut de la saisie
// nReductionLargeur : pour la saisie dans le champ table : on ne prend pas toute la largeur
WDPopupSaisiePlanning.prototype._vDebut = function _vDebut(oConteneurParent, nReductionLargeur, oRendezVous)
{
	// Appel de la classe de base
	WDPopupSaisie.prototype._vDebut.apply(this, arguments);

	// Memorise le rendez-vous
	this.m_oRendezVous = oRendezVous;
	// Force la valeur
	this.m_oSaisie.value = oRendezVous.m_sTitre;
};

// Valide la saisie
WDPopupSaisiePlanning.prototype._vValide = function _vValide(oEvent, sValeur)
{
	// Appel de la classe de base
	WDPopupSaisie.prototype._vValide.apply(this, arguments);

	// Appel du champ
	this.m_oObjetParent.OnRendezVousValideSaisie(oEvent, this.m_oRendezVous, sValeur);
};

// Annule la saisie
WDPopupSaisiePlanning.prototype._vAnnule = function _vAnnule()
{
	// Libere nos valeurs
	this.m_oRendezVous = null;
	delete this.m_oRendezVous;

	// Appel de la classe de base
	WDPopupSaisie.prototype._vAnnule.apply(this, arguments);
};

// Manipulation d'un rendez-vous du champ planning
// oRendezVous : structure du champ planning contenant les donnees du rendez-vous (cette classe n'est qu'un wrapper)
function WDRendezVous(oChampPlanning, oRendezVous)
{
	// Appel le constructeur de la classe de base
	// Si un jour on derive de la classe, mettre un parametre pour proteger l'appel
	WDTypeAvance.prototype.constructor.apply(this, []);

	if (oChampPlanning && oRendezVous)
	{
		this.m_oChampPlanning = oChampPlanning;
		this.m_oRendezVous = oRendezVous;
	}
};

// Declare l'heritage
WDRendezVous.prototype = new WDTypeAvance(true);
// Surcharge le constructeur qui a ete efface
WDRendezVous.prototype.constructor = WDRendezVous;

// Lire une propriete
WDRendezVous.prototype.GetProp = function GetProp(nPropriete)
{
	switch (nPropriete)
	{
	case 0:		// Titre
		return this.m_oRendezVous.m_sTitre;
	case 1:		// CouleurFond
		return this.m_oRendezVous.m_sCouleur;
	case 2:		// DateDebut : format AAAAMMJJHHMMSSCCC
		return this.__DateHeure2WL(this.m_oRendezVous.m_oDateDebut);
	case 3:		// DateFin : format AAAAMMJJHHMMSSCCC
		return this.__DateHeure2WL(this.m_oRendezVous.m_oDateFin);
	case 4:		// Contenu
		return this.m_oRendezVous.m_sContenu;
	case 16: // Ressource
		return this.m_oChampPlanning.sGetNomRessource(this.m_oRendezVous.m_nRessource);
	default:
		return WDTypeAvance.prototype.GetProp.apply(this, arguments);
	}
};

WDRendezVous.prototype.__DateHeure2WL = function __DateHeure2WL(oDate)
{
	// Pas d'utilisation de "JS_DateToWD" ("_JDTW") car on utilise la date en UTC (pour avoir la meme reponse quelque soit l'endroit de consultation)
	var tabResultat = [];
	var nTemp;
	// L'annee est >= 1970
	tabResultat.push(oDate.getUTCFullYear());
	// Le moins est entre 0 et 11
	t = oDate.getUTCMonth() + 1;
	tabResultat.push(((t < 10) ? "0" : "") + t);
	// Le jour est entre 1 et 31
	t = oDate.getUTCDate();
	tabResultat.push(((t < 10) ? "0" : "") + t);
	// Les heures (entre 0 et 23)
	t = oDate.getUTCHours();
	tabResultat.push(((t < 10) ? "0" : "") + t);
	t = oDate.getUTCMinutes();
	tabResultat.push(((t < 10) ? "0" : "") + t);
	t = oDate.getUTCSeconds();
	tabResultat.push(((t < 10) ? "0" : "") + t);
	t = oDate.getUTCMilliseconds();
	tabResultat.push(((t < 100) ? ((t < 10) ? "00" : "0") : "") + t);
	return tabResultat.join("");
};

// Manipulation d'une repetition de rendez-vous
function WDRepetition()
{
	// Appel le constructeur de la classe de base
	// Si un jour on derive de la classe, mettre un parametre pour proteger l'appel
	WDTypeAvance.prototype.constructor.apply(this, [true]);
};

// Declare l'heritage
WDRepetition.prototype = new WDTypeAvance();
// Surcharge le constructeur qui a ete efface
WDRepetition.prototype.constructor = WDRepetition;

// Lire une propriete
WDRepetition.prototype.GetProp = function GetProp(nPropriete)
{
	switch (sPropriete)
	{
	default:
		return WDTypeAvance.prototype.GetProp.apply(this, arguments);
	}
};
